#include<iostream>
#include<cstdio>
#include<cstring>
#include<cmath>
#define MAXN 100010
#define SQRTMAXN 1000
#define INF 2147483647
using namespace std;
inline int read()
{
	int x=0,t=1,c;
	while(!isdigit(c=getchar()))if(c=='-')t=-1;
	while(isdigit(c))x=x*10+c-'0',c=getchar();
	return x*t;
}
struct Block
{
	int value[SQRTMAXN],size;
	int maxv,minv;
	Block()
	{
		memset(value,0,sizeof(value));
		maxv=-INF;
		minv=INF;
		size=0;
	}
	void Maintain()
	{
		if(size)maxv=minv=value[0];
		else maxv=-INF,minv=INF;
		for(int i=1;i<size;i++)
		{
			maxv=max(maxv,value[i]);
			minv=min(minv,value[i]);
		}
	}
	void Insert(int x,int v)
	{
		size++;
		for(int i=size-1;i>x;i--)value[i]=value[i-1];
		value[x]=v;
		maxv=max(maxv,v);
		minv=min(minv,v);
	}
	void InsertBack(int v)
	{
		Insert(size,v);
	}
	void Delete(int x)
	{
		size--;
		for(int i=x;i<size;i++)value[i]=value[i+1];
		Maintain();
	}
	void DeleteBack()
	{
		Delete(size-1);
	}
	void Change(int x,int v)
	{
		bool maintain=0;
		if(value[x]==minv||value[x]==maxv)maintain=1;
		value[x]=v;
		if(maintain)Maintain();
	}
	void Split(Block *b)
	{
		int halfsize=size/2;
		for(int i=halfsize;i<size;i++)b->InsertBack(value[i]);
		size=halfsize;
	}
};
int splitsize=700;
struct WorkSpace
{
	Block blocks[SQRTMAXN];
	int cntb;
	Block Main;
	WorkSpace()
	{
		cntb=1;
		Main.InsertBack(0);
	}
	int GetValue(int x)
	{
		for(int i=0,sz=0;i<Main.size;i++)
		{
			if(sz+blocks[Main.value[i]].size>x)
			{
				return blocks[Main.value[i]].value[x-sz];
			}
			sz+=blocks[Main.value[i]].size;
		}
		return -1;
	}
	void Insert(int x,int v)
	{
		for(int i=0,sz=0;i<Main.size;i++)
		{
			if(sz+blocks[Main.value[i]].size>=x)
			{
				blocks[Main.value[i]].Insert(x-sz,v);
				if(blocks[Main.value[i]].size>=splitsize)
				{
					blocks[Main.value[i]].Split(&blocks[cntb]);
					Main.Insert(i+1,cntb);
					cntb++;
				}
				return;
			}
			sz+=blocks[Main.value[i]].size;
		}
	}
	void Delete(int x)
	{
		for(int i=0,sz=0;i<Main.size;i++)
		{
			if(sz+blocks[Main.value[i]].size>x)
			{
				blocks[Main.value[i]].Delete(x-sz);
				return;
			}
			sz+=blocks[Main.value[i]].size;
		}
	}
	int GetMax(int L,int R)
	{
		int ret=-INF;
		for(int i=0,sz=0;i<Main.size;i++)
		{
			int l=sz,r=l+blocks[Main.value[i]].size-1;
			l=max(l,L);r=min(r,R);
			if(l<=r)
			{
				if(l==sz&&r==sz+blocks[Main.value[i]].size-1)
					ret=max(ret,blocks[Main.value[i]].maxv);
				else
					for(int j=l-sz;j<=r-sz;j++)
						ret=max(ret,blocks[Main.value[i]].value[j]);
			}
			sz+=blocks[Main.value[i]].size;
		}
		return ret;
	}
	int GetMin(int L,int R)
	{
		int ret=INF;
		for(int i=0,sz=0;i<Main.size;i++)
		{
			int l=sz,r=l+blocks[Main.value[i]].size-1;
			l=max(l,L);r=min(r,R);
			if(l<=r)
			{
				if(l==sz&&r==sz+blocks[Main.value[i]].size-1)
					ret=min(ret,blocks[Main.value[i]].minv);
				else
					for(int j=l-sz;j<=r-sz;j++)
						ret=min(ret,blocks[Main.value[i]].value[j]);
			}
			sz+=blocks[Main.value[i]].size;
		}
		return ret;
	}
	void GetInfo(int L,int R,int &maxv,int &minv)
	{
		maxv=-INF,minv=INF;
		for(int i=0,sz=0;i<Main.size;i++)
		{
			int l=sz,r=l+blocks[Main.value[i]].size-1;
			l=max(l,L);r=min(r,R);
			if(l<=r)
			{
				if(l==sz&&r==sz+blocks[Main.value[i]].size-1)
					minv=min(minv,blocks[Main.value[i]].minv),
					maxv=max(maxv,blocks[Main.value[i]].maxv);
				else
					for(int j=l-sz;j<=r-sz;j++)
						maxv=max(maxv,blocks[Main.value[i]].value[j]),
						minv=min(minv,blocks[Main.value[i]].value[j]);
			}
			sz+=blocks[Main.value[i]].size;
		}
	}
	void Change(int x,int v)
	{
		for(int i=0,sz=0;i<Main.size;i++)
		{
			if(sz+blocks[Main.value[i]].size>x)
			{
				blocks[Main.value[i]].Change(x-sz,v);
				return;
			}
			sz+=blocks[Main.value[i]].size;
		}
	}
}workspace,diffworkspace;
char order[10];
int main()
{
	freopen("atom.in","r",stdin);
	freopen("atom.out","w",stdout);
	int N=read(),M=read();
	workspace.Insert(0,0);
	for(int i=0;i<N;i++)workspace.Insert(i+1,read());
	workspace.Insert(N+1,0);
	for(int i=0;i<=N;i++)diffworkspace.Insert(i,abs(workspace.GetValue(i)-workspace.GetValue(i+1)));
	for(int i=0;i<M;i++)
	{
		scanf("%s",order);
		if(order[1]=='a')
		{
			int x=read(),y=read(),Min,Max;
			workspace.GetInfo(x,y,Max,Min);
			printf("%d\n",Max-Min);
		}
		else if(order[1]=='i')
		{
			int x=read(),y=read();
			printf("%d\n",diffworkspace.GetMin(x,y-1));
		}
		else if(order[1]=='n')
		{
			int x=read(),e=read(),vx=workspace.GetValue(x),vx1=workspace.GetValue(x+1);
			workspace.Insert(x+1,e);
			diffworkspace.Change(x,abs(e-vx));
			diffworkspace.Insert(x+1,abs(e-vx1));
		}
		else if(order[1]=='e')
		{
			int x=read(),e=read(),vx_1=workspace.GetValue(x-1),vx2=workspace.GetValue(x+2);
			workspace.Delete(x+1);
			workspace.Change(x,e);
			diffworkspace.Delete(x+1);
			diffworkspace.Change(x-1,abs(vx_1-e));
			diffworkspace.Change(x,abs(vx2-e));
		}
	}
}
/*
ren ping tian xia feng yu bian
xiao sa li yu ren shi jian
*/
