#include <iostream>
#include <cstdio>
#include <cmath>
using namespace std;

struct Node {
	int l, r, Max, Min, ansMin;
	Node *lch, *rch;
	void clear() { l = r = Max = Min = 0; ansMin = 1e9; lch = rch = 0; }
};
typedef Node* pNode;

int n, m, e[10010];
void Update(pNode &now) {
	now->l = now->lch->l;
	now->r = now->rch->r;	
	now->Max = max(now->lch->Max, now->rch->Max);
	now->Min = min(now->lch->Min, now->rch->Min);	
	now->ansMin = min(now->lch->ansMin, now->rch->ansMin);
	now->ansMin = min(now->ansMin, abs(e[now->lch->r] - e[now->rch->l]));
}

pNode Build(int l, int r) {
	pNode now = new Node;
	now->l = l, now->r = r;
	if (l == r)
	{
		now->lch = now->rch = 0;
		now->Max = now->Min = e[l];
		now->ansMin = 1e9;
		return now;
	}
	int mid = (l+r)/2;
	now->lch = Build(l, mid);
	now->rch = Build(mid+1, r);
	Update(now);
	return now;
}

int get_Max(pNode now, int st, int ed) {
	if (st <= now->l && ed >= now->r)
		return now->Max;
	int mid = (now->l + now->r) / 2, ret = 0;
	if (ed <= mid)
		return get_Max(now->lch, st, ed);
	else if (st > mid)
		return get_Max(now->rch, st, ed);
	else
		return max(get_Max(now->lch, st, mid), get_Max(now->rch, mid+1, ed));
}

int get_Min(pNode now, int st, int ed) {
	if (st <= now->l && ed >= now->r)
		return now->Min;
	int mid = (now->l + now->r) / 2, ret = 1e9;
	if (ed <= mid)
		return get_Min(now->lch, st, ed);
	else if (st > mid)
		return get_Min(now->rch, st, ed);
	else
		return min(get_Min(now->lch, st, mid), get_Min(now->rch, mid+1, ed));
}

pNode get_ansMin(pNode now, int st, int ed) {
	pNode ret = new Node;
	
	if (st == now->l && ed == now->r)
		return now;
	int mid = (now->l + now->r) / 2;
	ret->clear();
	if (ed <= mid)
		ret = get_ansMin(now->lch, st, ed);
	else if (st > mid)
		ret = get_ansMin(now->rch, st, ed);
	else
	{
		ret->lch = get_ansMin(now->lch, st, mid);
		ret->rch = get_ansMin(now->rch, mid+1, ed);
		Update(ret);
	}
	return ret;
}

pNode root = 0;
int main() {
	freopen("atom.in", "r", stdin);
	freopen("atom.out", "w", stdout);
	ios::sync_with_stdio(false);
	cin >> n >> m;
	for (int i = 1; i <= n; ++i)
		cin >> e[i];
	root = Build(1, n);
	for (int i = 1; i <= m; ++i)
	{
		string op;
		int x, y;
		cin >> op >> x >> y;
		if (op == "max")
		{
			int Max = get_Max(root, x, y), Min = get_Min(root, x, y);
			cout << Max - Min << endl;
		}
		if (op == "min")
			cout << get_ansMin(root, x, y)->ansMin << endl;
		if (op == "insert");
//			Insert(root, x, y);
		if (op == "merge");
//			Merge(root, x, y);
	}
	return 0;
}
/*
10 100
11 5 7 9 6 7 15 33 1 9
*/
