#include <iostream>
#include <cstdio>
#include <cmath>

#define MAXN 300010

using namespace std;

typedef long long ll;

int n, k;
ll r;
ll l[MAXN];
ll s[MAXN];
ll S;
ll dlt = INT_MAX;

struct segment {
	int l, r;
	ll s;
} e[MAXN];

int move(int x, int type) {
	if(type == -1) x = (x + n - 2) % n + 1;
	if(type == 1) x = x % n + 1;
	return x;
}

void check() {
	bool op = true;
	while(op) {
		op = false;
		for(int i = 1; i <= k; i++) {
			int j = i % k + 1;
			int rt = move(e[i].r, -1);
			int lt = e[j].l;
			if(e[i].s > e[j].s){
				if(abs(e[i].s - e[j].s - 2 * l[rt]) <= e[i].s - e[j].s) {
					e[i].s -= l[rt];
					e[j].s += l[rt];
					e[i].r = move(e[i].r, -1);
					e[j].l = move(e[j].l, -1);
					op = true;
				}
			}
			if(e[j].s > e[i].s)
				if(abs(e[j].s - e[i].s - 2 * l[lt]) < e[j].s - e[i].s) {
					e[i].s += l[lt];
					e[j].s -= l[lt];
					e[i].r = move(e[i].r, 1);
					e[j].l = move(e[j].l, 1);
					op = true;
				}
		}
	}
}

void solve2(int x, int y) {
	if(!dlt) return;
	if(y > 1 && x >= y) return;
	ll st;
	if(x <= y) st = s[y - 1] - s[x - 1];
	else st = S - s[x - 1] + s[y - 1];
	if(S == 2 * st) dlt = 0;
	else if(S > 2 * st) {
		if(dlt > abs(S - 2 * st - 2 * l[y])) dlt = abs(S - 2 * st - 2 * l[y]);
		solve2(x, move(y, 1));
	}
	else if(2 * st > S) {
		if(dlt > abs(2 * st - S - 2 * l[x])) dlt = abs(2 * st - S - 2 * l[x]);
		solve2(move(x, 1), y);
	}
}

int main() {
	freopen("spaceship.in", "r", stdin);
	freopen("spaceship.out", "w", stdout);
	scanf("%d %d", &n, &k);
	for(int i = 1; i <= n; i++) {
		scanf("%lld", &l[i]);
		s[i] = s[i - 1] + l[i];
	}
	S = s[n];
	if(k == 2) {
		solve2(1, 1);
		r += k * k * (S * S + dlt * dlt) / 2;
		r -= k * S * S;
	}
	else {
		e[k].s = S;
		int t = 1;
		for(int i = 1; i <= k - 1; i++) {
			e[i].l = t;
			while((e[i].s + l[t]) * k < S) {
				e[i].s += l[t];
				t += 1;
			}
			e[i].r = t;
			e[k].s -= e[i].s;
		}
		e[k].l = t;
		e[k].r = 1;
		check();
		for(int i = 1; i <= k; i++)
			r += k * k * e[i].s * e[i].s;
		r -= k * S * S;
	}
	printf("%lld", r);
	return 0;
}
