#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cctype>
#include <algorithm>
using namespace std;

int read() {
	int x = 0, f = 1; char c = getchar();
	while(!isdigit(c)){ if(c == '-') f = -1; c = getchar(); }
	while(isdigit(c)){ x = x * 10 + c - '0'; c = getchar(); }
	return x * f;
}

#define maxnode 400010
#define maxn 100010
struct Node {
	int v, mx, mn, siz;
	Node() {}
	Node(int _): v(_) {}
} ns[maxnode];
int rt1, rt2, ToT, fa[maxnode], ch[maxnode][2], rec[maxn], rcnt, E[maxn];
int getnode() {
	if(rcnt) {
		int o = rec[rcnt--];
		fa[o] = ch[o][0] = ch[o][1] = 0;
		return o;
	}
	return ++ToT;
}
void maintain(int o) {
	ns[o].siz = 1; ns[o].mx = ns[o].mn = ns[o].v;
	for(int i = 0; i < 2; i++) if(ch[o][i])
		ns[o].siz += ns[ch[o][i]].siz,
		ns[o].mx = max(ns[o].mx, ns[ch[o][i]].mx),
		ns[o].mn = min(ns[o].mn, ns[ch[o][i]].mn);
	return ;
}
void build(int& o, int L, int R) {
	if(L > R) return ;
	int M = L + R >> 1; ns[o = getnode()] = Node(E[M]);
	build(ch[o][0], L, M - 1); build(ch[o][1], M + 1, R);
	if(ch[o][0]) fa[ch[o][0]] = o;
	if(ch[o][1]) fa[ch[o][1]] = o;
	return maintain(o);
}
void rotate(int u) {
	int y = fa[u], z = fa[y], l = 0, r = 1;
	if(z) ch[z][ch[z][1]==y] = u;
	if(ch[y][1] == u) swap(l, r);
	fa[u] = z; fa[y] = u; fa[ch[u][r]] = y;
	ch[y][l] = ch[u][r]; ch[u][r] = y;
	maintain(y); maintain(u);
	return ;
}
void splay(int u) {
	while(fa[u]) {
		int y = fa[u], z = fa[y];
		if(z) {
			if(ch[z][0] == y ^ ch[y][0] == u) rotate(u);
			else rotate(y);
		}
		rotate(u);
	}
	return ;
}
int Find(int o, int k) {
	if(!o) return 0;
	int ls = ch[o][0] ? ns[ch[o][0]].siz : 0;
	if(k == ls + 1) return o;
	if(k > ls + 1) return Find(ch[o][1], k - ls - 1);
	return Find(ch[o][0], k);
}
int split(int u) {
	if(!u) return 0;
	splay(u);
	int tmp = ch[u][1];
	fa[tmp] = ch[u][1] = 0;
	return maintain(u), tmp;
}
int merge(int a, int b) {
	if(!a) return b;
	if(!b) return a;
	while(ch[a][1]) a = ch[a][1];
	splay(a);
	ch[a][1] = b; fa[b] = a;
	return maintain(a), a;
}
void recycle(int& o) {
	if(!o) return ;
	recycle(ch[o][0]); recycle(ch[o][1]);
	rec[++rcnt] = o; o = 0;
	return ;
}

int main() {
	freopen("atom.in", "r", stdin);
	freopen("atom.out", "w", stdout);
	int n = read(), q = read();
	for(int i = 1; i <= n; i++) E[i] = read();
	build(rt1, 1, n);
	for(int i = 1; i < n; i++) E[i] = abs(E[i+1] - E[i]);
	build(rt2, 1, n - 1);
	
	char cmd[10];
	while(q--) {
		scanf("%s", cmd);
		if(!strcmp(cmd, "merge")) {
			int x = read(), v = read();
			
			int lrt = Find(rt1, x - 1), mrt = Find(rt1, x + 1), rrt, tmpl, tmpr;
			split(lrt); tmpl = ns[lrt].v; rrt = split(mrt); tmpr = ns[rrt].v;
			recycle(mrt); ns[mrt = getnode()] = Node(v); maintain(mrt);
			lrt = merge(lrt, mrt); rt1 = merge(lrt, rrt);
			
			lrt = Find(rt2, x - 1); mrt = Find(rt2, x);
			split(lrt); rrt = split(mrt);
			recycle(mrt);
			if(lrt) ns[lrt] = Node(abs(tmpl - v)), maintain(lrt);
			if(rrt) ns[rrt] = Node(abs(tmpr - v)), maintain(rrt);
			rt2 = merge(lrt, rrt);
		}
		if(!strcmp(cmd, "insert")) {
			int x = read(), v = read();
			
			int lrt = Find(rt1, x), mrt = 0, rrt = split(lrt), tmpl = ns[lrt].v, tmpr = ns[Find(rrt,1)].v;
			ns[mrt = getnode()] = Node(v); maintain(mrt);
			lrt = merge(lrt, mrt); rt1 = merge(lrt, rrt);
			
			lrt = Find(rt2, x - 1); mrt = Find(rt2, x);
			split(lrt); rrt = split(mrt); if(!mrt) rrt = 0;
			if(mrt) {
				ns[mrt] = Node(abs(tmpl - v)); maintain(mrt);
				int tmp = 0; ns[tmp = getnode()] = Node(abs(tmpr - v)); maintain(tmp);
//				printf("mrt: %d %d %d\n", ns[mrt].v, ns[tmp].v, tmpr);
				mrt = merge(mrt, tmp);
			}
			else ns[mrt = getnode()] = Node(abs(tmpl - v)), maintain(mrt);
			lrt = merge(lrt, mrt); rt2 = merge(lrt, rrt);
		}
		if(!strcmp(cmd, "max")) {
			int ql = read(), qr = read();
			
			int lrt = Find(rt1, ql - 1), mrt = Find(rt1, qr), rrt;
			split(lrt); rrt = split(mrt);
			printf("%d\n", ns[mrt].mx - ns[mrt].mn);
			lrt = merge(lrt, mrt); rt1 = merge(lrt, rrt);
		}
		if(!strcmp(cmd, "min")) {
			int ql = read(), qr = read() - 1;
			
			int lrt = Find(rt2, ql - 1), mrt = Find(rt2, qr), rrt;
			split(lrt); rrt = split(mrt);
			printf("%d\n", ns[mrt].mn);
			lrt = merge(lrt, mrt); rt2 = merge(lrt, rrt);
		}
	}
	
	return 0;
}
