#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cctype>
#include <algorithm>
using namespace std;

int read() {
	int x = 0, f = 1; char c = getchar();
	while(!isdigit(c)){ if(c == '-') f = -1; c = getchar(); }
	while(isdigit(c)){ x = x * 10 + c - '0'; c = getchar(); }
	return x * f;
}

#define maxn 300010
#define maxnf 410
#define maxk 25
#define oo (1ll << 60)
#define LL long long
int n, K, L[maxn], S[maxn];

LL sqr(LL a){ return a * a; }

LL calc(int l, int r) {
	int S1 = S[r] - S[l-1], S2 = S[n] - S1;
	return sqr((LL)K * S1 - S[n]) + sqr((LL)K * S2 - S[n]);
}
void solve1() {
	LL ans = oo;
	for(int R = 1; R <= n; R++) {
		int l = 1, r = R, len = r - l + 1, m1 = l + len / 3, m2 = m1 + len / 3;
		while(m1 - l > 1 || m2 - m1 > 1 || r - m2 > 1) {
//			printf("before %d %d %d %d\n", l, m1, m2, r);
			if(calc(m1, R) > calc(m2, R)) l = m1; else r = m2;
			len = r - l + 1; m1 = l + len / 3; m2 = m1 + len / 3;
//			printf("after %d %d %d %d\n", l, m1, m2, r);
		}
		ans = min(ans, min((calc(l, R), calc(r, R)), min(calc(m1, R), calc(m2, R))));
	}
	printf("%lld\n", ans);
	return ;
}
void solve1_force() {
//	solve1();
	LL ans = oo;
	for(int l = 1; l <= n; l++)
		for(int r = l; r <= n; r++) {
			int S1 = S[r] - S[l-1], S2 = S[n] - S1;
			LL tmp = sqr((LL)K * S1 - S[n]) + sqr((LL)K * S2 - S[n]);
			ans = min(ans, tmp);
		}
	printf("%lld\n", ans);
	return ;
}
void solve2() {
	LL ans = oo;
	for(int l = 1; l <= n; l++)
		for(int m = l; m <= n; m++)
			for(int r = m + 1; r <= n; r++) {
				int S1 = S[m] - S[l-1], S2 = S[r] - S[m], S3 = S[n] - S1 - S2;
				LL tmp = sqr((LL)K * S1 - S[n]) + sqr((LL)K * S2 - S[n]) + sqr((LL)K * S3 - S[n]);
				ans = min(ans, tmp);
			}
	printf("%lld\n", ans);
	return ;
}

struct Point {
	LL x, y;
	Point() {}
	Point(LL _, LL __): x(_), y(__) {}
} ps[maxn];
LL f[maxnf][maxk];
int q[maxn], hd, tl;
bool isup(int a, int b, int c) {
	LL x1 = ps[b].x - ps[a].x, y1 = ps[b].y - ps[a].y, x2 = ps[c].x - ps[b].x, y2 = ps[c].y - ps[b].y;
	return y1 * x2 - x1 * y2 > 0;
}
bool bigger(LL k, int a, int b) {
	LL x = ps[b].x - ps[a].x, y = ps[b].y - ps[a].y;
	return k * x > y;
}
int L2[maxn];
void solve3() {
	LL ans = oo;
	for(int st = 1; st <= n; st++) {
		int cnt = 0;
		for(int i = st; i <= n; i++) L2[++cnt] = L[i];
		for(int i = 1; i < st; i++) L2[++cnt] = L[i];
		for(int i = 1; i <= n; i++) S[i] = S[i-1] + L2[i];
		memset(f, 0, sizeof(f));
		for(int i = 1; i <= n; i++) f[i][1] = sqr((LL)K * S[i] - S[n]);
		for(int j = 2; j <= K; j++) {
			hd = 1; tl = 0;
			ps[j-1] = Point(S[j-1], f[j-1][j-1] + sqr((LL)K * S[j-1])); q[++tl] = j - 1;
			for(int i = j; i <= n; i++) {
				LL slop = 2ll * sqr(K) * S[i] - 2ll * K * S[n];
				while(hd < tl && bigger(slop, q[hd], q[hd+1])) hd++;
				f[i][j] = ps[q[hd]].y - slop * ps[q[hd]].x + sqr(S[n]) + sqr((LL)K * S[i]) - 2ll * K * S[n] * S[i];
				ps[i] = Point(S[i], f[i][j-1] + sqr((LL)K * S[i]));
				while(hd < tl && isup(q[tl-1], q[tl], i)) tl--; q[++tl] = i;
			}
		}
		ans = min(ans, f[n][K]);
	}
	printf("%lld\n", ans);
	return ;
}

int main() {
	freopen("spaceship.in", "r", stdin);
	freopen("spaceship.out", "w", stdout);
	n = read(); K = read();
	for(int i = 1; i <= n; i++) L[i] = read(), S[i] = S[i-1] + L[i];
	
	if(K == 2 && n <= 5000) solve1_force();
	else if(K == 2) solve1();
	else if(K == 3 && n <= 200) solve2();
	else solve3(); // */
	
	return 0;
}
