#include <cstdio>
#include <iostream>
#include <algorithm>
#include <cstring>
#define MAXN 300001
#define INF 1000000007
using namespace std;
typedef struct node_t *node;
int n;
struct node_t{
	node l,r,pre;
	int num;
	int maxx;
	int minn;
	int miax;
	int size;
	node_t(){
		l=r=pre=NULL;
		maxx=size=0;
		minn=miax=INF;
	}
}npool[MAXN],*root;
int cnt=0;
inline int size(node t){
	if(t==NULL) return 0;
	return t->size;
}inline int maxx(node t){
	if(t==NULL) return 0;
	return t->maxx;
}inline int minn(node t){
	if(t==NULL) return INF;
	return t->minn;
}inline int miax(node t){
	if(t==NULL) return INF;
	return t->miax;
}inline int num(node t){
	if(t==NULL) return -INF;
	return t->num;
}

inline void update(node t){
	t->size=size(t->l)+size(t->r)+1;
	if(num(t)!=-INF){
		t->maxx=max(max(maxx(t->l),maxx(t->r)),num(t));
		t->minn=min(min(minn(t->l),minn(t->r)),num(t));
		t->miax=min(min(abs(num(t->l)-t->num),abs(num(t->r)-num(t))),min(miax(t->l),miax(t->r)));
	}
}

void rotate(node x,bool left){
	
	node y=x->pre;
	x->pre=y->pre;
	if(y->pre!=NULL){
		if(y==y->pre->l)y->pre->l=x;
		else y->pre->r=x;
	}
	y->pre=x;
	node b;
	if(left){
		y->l=b=x->r;
		x->r=y;
	}else{
		y->r=b=x->l;
		x->l=y;
	}
	if(b!=NULL){
		b->pre=y;
	}
	if(root==y)
		root=x;
	
	update(y);
	update(x);
}

void splay(node x,node f){
	while(x->pre!=f){
		if(x->pre->pre==f){
			if(x->pre->l==x){
				rotate(x,1);
			}else{
				rotate(x,0);
			}
		} else{
			node y=x->pre;
			node z=y->pre;
			if(y==z->l){
				if(x==y->l){
					rotate(y,1);rotate(x,1);
				}else{
					rotate(x,0);rotate(x,1);
				}
			}else if(y==z->r){
				if(x==y->r){
					rotate(y,0);rotate(x,0);
				}else{
					rotate(x,1);rotate(x,0);
				}
			}
		}
		update(x);
	}
	return;
}

node search(int k,node rt){
	if(k<size(rt->l)) 
		return search(k,rt->l);
	else if(k==size(rt->l)){
		return rt;
	}else{
		return search(k-size(rt->l)-1,rt->r);
	}
}

node make(int *a,int l,int r){
	if(l==r) return NULL;
	int mid=(l+r)/2;
	npool[cnt].num=a[mid];
	node now=npool+cnt++;
	node lt=make(a,l,mid);
	node rt=make(a,mid+1,r);
	if(lt!=NULL) lt->pre=now;
	if(rt!=NULL) rt->pre=now;
	now->l=lt;
	now->r=rt;
	update(now);
	return now;
}
int m;

int main(){
	freopen("atom.in","r",stdin);
	freopen("atom.out","w",stdout);
	cin>>n>>m;
	int a[MAXN];
	for(int i=1;i<=n;i++){
		cin>>a[i];
	}
	a[0]=-INF;
	a[n+1]=-INF;
	root=make(a,0,n+2);
	string str;
	for(int i=0;i<m;i++){
		cin>>str;
		if(str=="max"){
			int m,n;
			cin>>m>>n;
			splay(search(m-1,root),NULL);
			splay(search(n+1,root),root);
			cout<<root->r->l->maxx-root->r->l->minn<<endl;
		}if(str=="min"){
			int m,n;
			cin>>m>>n;
			splay(search(m-1,root),NULL);
			splay(search(n+1,root),root);
			cout<<root->r->l->miax<<endl;
		}
		if(str=="merge"){
			int x,e;
			cin>>x>>e;
			splay(search(x-1,root),NULL);
			splay(search(x+2,root),root);
			node p=root->r->l;
			p->l=p->r=NULL;
			p->num=e;
			p->minn=INF;
			p->maxx=0;
			p->miax=INF;
			p->size=1;
			update(p);
			update(p->pre);
		}if(str=="insert"){
			int x,e;
			cin>>x>>e;
			splay(search(x,root),NULL);
			splay(search(x+1,root),root);
			node p=root->r->l=&npool[cnt++];
			p->l=p->r=NULL;
			p->num=e;
			p->minn=INF;
			p->maxx=0;
			p->miax=INF;
			p->size=1;
			p->pre=root->r;
			update(p);
			update(p->pre);

		}
	}
	return 0;
}

