#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <algorithm>

using namespace std;

const int MAXN = 300000 + 100;
const int MAXM = 20 + 5;

const long long INF = 0x1f1f1f1f1f1f1f1fll;


long long sqr(long long x)
{
	return x * x;	
}

int n, m;
int a[MAXN];

namespace Case2
{
	const int MAXN = 100000 + 100;
	const int MAXM = 20 + 5;
	
	long long sum, s[2 * MAXN];
	long long ans;
	
	long long solve()
	{
		long long ret = INF;
		int j = 1, cur = 0;
		for(int i = 1; i <= n; i++)
		{
			while(j < i + n && (s[j] - s[i - 1]) * m <= sum)
				j++;
//			cout << i << ' ' << j << endl;
			ret = min(ret, 2 * sqr((s[j - 1] - s[i - 1]) * m - sum));
		}
		return ret;
	}
	
	void work()
	{
		sum = 0;
		for(int i = 1; i <= n; i++)
			sum += a[i];
		s[0] = 0;
		for(int i = 1; i <= 2 * n; i++)
			s[i] = s[i - 1] + a[(i - 1) % n + 1];
		ans = INF;
		ans = min(ans, solve());
		cout << ans << endl;
	}
}

namespace Case3
{
	const int MAXN = 300000 + 100;
	const int MAXM = 20 + 5;
	
	long long sum, s[2 * MAXN];
	long long ans;
	
	long long solve1()
	{
		long long ret = INF;
		int j = 1, k = 1, cur = 0;
		for(int i = 1; i <= n; i++)
		{
			while(j < i + n && (s[j] - s[i - 1]) * m <= sum)
			{
				j++;
				if(i < j && j < k)
				{	
					long long tmp = 0;
					tmp += sqr((s[j - 1] - s[i - 1]) * m - sum);
					tmp += sqr((s[k - 1] - s[j - 1]) * m - sum);
					tmp += sqr((sum - (s[k - 1] - s[i - 1])) * m - sum);
					ret = min(ret, tmp);
				}
			}	
			while(k < i + n && (s[k] - s[j - 1]) * m <= sum)
			{
				k++;
//				cout << i << ' ' << j << ' ' << k << ' ' << endl;
				if(i < j && j < k)
				{	
					long long tmp = 0;
					tmp += sqr((s[j - 1] - s[i - 1]) * m - sum);
					tmp += sqr((s[k - 1] - s[j - 1]) * m - sum);
					tmp += sqr((sum - (s[k - 1] - s[i - 1])) * m - sum);
					ret = min(ret, tmp);
				}
			}
		}
		return ret;
	}
	long long solve2()
	{
		long long ret = INF;
		int j = 1, k = 1, cur = 0;
		for(int i = 1; i <= n; i++)
		{
			while(j < i + n && (s[j - 1] - s[i - 1]) * m < sum)
			{
				j++;
				if(i < j && j < k)
				{	
					long long tmp = 0;
					tmp += sqr((s[j - 1] - s[i - 1]) * m - sum);
					tmp += sqr((s[k - 1] - s[j - 1]) * m - sum);
					tmp += sqr((sum - (s[k - 1] - s[i - 1])) * m - sum);
					ret = min(ret, tmp);
				}
			}
			while(k < i + n && (s[k - 1] - s[j - 1]) * m < sum)
			{
				k++;
//				cout << i << ' ' << j << ' ' << k << ' ' << endl;
				if(i < j && j < k)
				{	
					long long tmp = 0;
					tmp += sqr((s[j - 1] - s[i - 1]) * m - sum);
					tmp += sqr((s[k - 1] - s[j - 1]) * m - sum);
					tmp += sqr((sum - (s[k - 1] - s[i - 1])) * m - sum);
					ret = min(ret, tmp);
				}
			}
		}
		return ret;
	}
	
	void work()
	{
		sum = 0;
		for(int i = 1; i <= n; i++)
			sum += a[i];
		s[0] = 0;
		for(int i = 1; i <= 2 * n; i++)
			s[i] = s[i - 1] + a[(i - 1) % n + 1];
		ans = INF;
		ans = min(ans, solve1());
		ans = min(ans, solve2());
		cout << ans << endl;
	}
}

namespace CaseDp
{
	const int MAXN = 400 + 10;
	const int MAXM = 20 + 5;
	
	long long sum, s[MAXN];
	long long f[MAXN][MAXM];
	long long ans;
	
	long long solve()
	{
		f[0][0] = 0;
		for(int i = 1; i <= n; i++)
			for(int j = 1; j <= m; j++)
			{
				f[i][j] = INF;
				for(int k = 0; k < i; k++)
					f[i][j] = min(f[i][j], f[k][j - 1] + sqr((s[i] - s[k]) * m - sum));
			}
		return f[n][m];
	}
	
	void work()
	{
		sum = 0;
		for(int i = 1; i <= n; i++)
			sum += a[i];
		ans = INF;
		memset(f, 31, sizeof(f));
		for(int i = 1; i <= n; i++)
		{
			s[0] = 0;
			for(int j = 1; j <= n; j++)
				s[j] = s[j - 1] + a[(i + j - 2) % n + 1];
			ans = min(ans, solve());
		}
		cout << ans << endl;
	}
}

int main()
{
	ios::sync_with_stdio(false);
	freopen("spaceship.in", "r", stdin);
	freopen("spaceship.out", "w", stdout);
	
	cin >> n >> m;
	for(int i = 1; i <= n; i++)
		cin >> a[i];
	if(n <= 400)
		CaseDp::work();
	else if(m == 2)
		Case2::work();
	else if(m == 3)
		Case3::work();
	
	return 0;
}
/*
5 2
4 2 6 1 3
*/

/*
5 3
4 2 6 1 3
*/

