#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <algorithm>
using namespace std;

#define SZ(x) ((x) ? (x)->sz : 0) 
struct node {
	int k, w, sz, mx, mn, jcmn;
	node* ch[2];
	static node* mkNod(node*);
	void up() {
		mn = mx = k; jcmn = 1E9;
		sz = 1;
		if(ch[0])
			mn = min(mn, ch[0]->mn), mx = max(mx, ch[0]->mx), jcmn = min(jcmn, min(abs(k - ch[0]->mx), ch[0]->jcmn)), sz += ch[0]->sz;
		if(ch[1])
			mn = min(mn, ch[1]->mn), mx = max(mx, ch[1]->mx), jcmn = min(jcmn, min(abs(ch[1]->mn - k), ch[1]->jcmn)), sz += ch[1]->sz;
		if(ch[0] && ch[1]) {
			jcmn = min(jcmn, abs(ch[1]->mn - ch[0]->mx));
			jcmn = min(jcmn, abs(ch[0]->mn - ch[1]->mx));
		}
	}
}; const int PSIZ = 2E6 + 1E3;
node POOL[PSIZ]; int ppos = 0;
node* GC[PSIZ]; int gpos = 0;

node* node::mkNod(node* c=NULL) {
	if(c) GC[gpos++] = c;
	else {
		c = gpos ? GC[--gpos] : &POOL[ppos++];
		c->w = rand(); c->k = c->mn = c->mn = c->jcmn = 0; c->sz = 1;
		if(c->ch[0]) node::mkNod(c->ch[0]);
		if(c->ch[1]) node::mkNod(c->ch[1]);
	}
	return c;
}

struct treap {
	node* root;
	treap() : root(NULL) { }
	void ins(node* &p, int pos, int v) {
		if(!p) { p = node::mkNod(); p->k = v; p->up(); }
		else {
			if(pos < SZ(p->ch[0])) {
				ins(p->ch[0], pos, v);
				if(p->ch[0]->w > p->w) {
					node* q = p; p = q->ch[0];
					q->ch[0] = p->ch[1];
					p->ch[1] = q;
				}
			} else {
				ins(p->ch[1], pos-SZ(p->ch[0])-1, v);
				if(p->ch[1]->w > p->w) {
					node* q = p; p = q->ch[1];
					q->ch[1] = p->ch[0];
					p->ch[0] = q;
				}
			}
			
			p->up();
		}
	}
	
	void ins(int pos, int v) { ins(root, pos, v); }
	
	void dfs(node* c, int dep = 0) {
		if(c == NULL) c = root;
		if(c->ch[0]) dfs(c->ch[0], dep + 2);
		for(int i=0;i<dep;i++) cout << " ";
		printf("%d %d %d %d %d\n", c->k, c->sz, c->mx, c->mn, c->jcmn);
		if(c->ch[1]) dfs(c->ch[1], dep + 2);
	}
	
	static void merge(node* &p, node* x, node* y) { // |x| < |y|
		if(!x || !y) p = x ? x : y;
		else {
			if(x->w > y->w) {
				p = x; merge(x->ch[1], x->ch[1], y);
			} else {
				p = y; merge(y->ch[0], x, y->ch[0]);
			}
			p->up();
		}
	}
	
	static void cut(node* p, node* &x, node* &y, int pos) {
		if(pos == 0) x = NULL, y = p;
		else if(SZ(p) == pos) x = p, y = NULL;
		else {
			if(pos < SZ(p->ch[0])) {
				merge(y, p->ch[1], y);
				cut(p->ch[0], x, y, pos);
			} else {
				merge(x, x, p->ch[0]);
				cut(p->ch[1], x, y, pos);
			}
			x->up(); y->up();
		}
	}
	
	void del(node* &p, int pos) {
		if(SZ(p) == 1) {
			node::mkNod(p);
			merge(p, p->ch[0], p->ch[1]);
			p = NULL;
		} else {
			if(pos < SZ(p->ch[0])) {
				del(p->ch[0], pos);
			} else {
				del(p->ch[1], pos-SZ(p->ch[0])-1);
			}
			p->up();
		}
	}
	
	void del(int pos) { del(root, pos); }
} t;

int N, M;

int main() {
	freopen("atom.in", "r", stdin);
	freopen("atom.out", "w", stdout);
	
	scanf("%d %d", &N, &M);
	
	int x;
	for(int i=0;i<N;i++) {
		scanf("%d", &x);
		t.ins(i, x);
	}
	
	char ss[64]; int a, b;
	for(int i=0;i<M;i++) {
		scanf("%s %d %d", ss, &a, &b);
		
		if(ss[1] == 'n') { // iNsert
			t.ins(a, b);
		} else if(ss[1] == 'e') { // mErge 
			t.del(a); t.dfs(NULL);
			t.ins(a, b); t.dfs(NULL);
			t.del(a); t.dfs(NULL);
		} else if(ss[1] == 'a') { // mAx
			node *p, *q, *c, *r;
			treap::cut(t.root, p, q, a);
			treap::cut(q, c, r, b-a+1);
			treap::merge(q, c, r); treap::merge(t.root, p, q);
		}
	}
}

