#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <limits>
#include <algorithm>
using namespace std;
typedef long long LL;
const int MAX_N = 4E5;

int N, K, M;
int N_1;
int L[MAX_N];
LL S1[MAX_N]; // Sum { Si } [0, i)
LL S2[MAX_N]; // Sum { sqr(Si) } [0, i)

LL getS1(int a, int b) { // [a, b]
	return S1[b + 1] - S1[a];
}

LL getS2(int a, int b) { // [a, b]
	return S2[b + 1] - S2[a];
}

void sub1() {
	double MinFC = numeric_limits<LL>::max();
	
	for(int i=0;i<N;i++) { // [i, i+N-1]
		for(int j=0;j<N_1;j++) { // Split
			int a = getS1(i, i+j), b = getS1(i+j+1, i+N-1);
			double mean = (a + b) / 2.0;
			MinFC = min(MinFC,
				(a*a + b*b) - ((mean * mean) * 2.0));
		}
	}
	
	cout << LL(MinFC) * K * K << endl;
}

const int AMX_N = 500;
const int MAX_K = 25;
struct state {
	double sum_2, avg;
} F[AMX_N][AMX_N][MAX_K];
void sub2() {
	//cout << "#" << getS2(0, 0) << " " << getS2(1, 2) << endl;
	
	for(int i=0;i<AMX_N;i++)
		for(int j=0;j<AMX_N;j++)
			for(int q=0;q<MAX_K;q++)
				F[i][j][q].sum_2 = 1E10;
	
	for(int i=0;i<=N;i++) {
		for(int j=0;j<=N;j++) { // [i, i+j]
			F[i][i+j][1].avg = getS1(i, i+j);
			F[i][i+j][1].sum_2 = F[i][i+j][1].avg * F[i][i+j][1].avg;
		}
	}
	
	for(int k=2;k<=K;k++) {
		for(int m=1;m<k;m++) {
			for(int i=0;i<N;i++) { // [i, i+j] + [i+j+1, i+N-1]
				for(int j=i;j<i+N;j++) {
					int _ = k-2;
					for(int p=i+_;p<j-_;p++) {
						double navg = F[i][p][m].avg * m + F[p+1][j][k-m].avg * (k - m);
						navg /= k;
						double nsum_2 = F[i][p][m].sum_2 + F[p+1][j][k-m].sum_2;
						
						if(nsum_2 - k * navg * navg < F[i][j][k].sum_2 - k * F[i][j][k].avg * F[i][j][k].avg) {
							F[i][j][k].avg = navg;
							F[i][j][k].sum_2 = nsum_2;
						}
					}
				}
			}
		}
	}
	
	double ans = 1E10;
	for(int i=0;i<N;i++) {
		ans = min(ans, F[i][i+N-1][K].sum_2 - K * F[i][i+N-1][K].avg * F[i][i+N-1][K].avg);
	}
	
	cout << LL(ans * K * K) << endl;
}

void sub3() {
	cout << rand() % 20 << endl;
}

int main() {
	freopen("spaceship.in", "r", stdin);
	freopen("spaceship.out", "w", stdout);
	
	scanf("%d %d", &N, &K); N_1 = N-1;
	
	for(int i=0;i<N;i++) {
		scanf("%d", &L[i]);
	}
	int M = N<<1;
	for(int i=N;i<M;i++) {
		L[i] = L[i-N];
	}
	
	S1[1] = L[0], S2[1] = L[0] * L[0];
	int _ = M+1;
	for(int i=2;i<=_;i++) {
		S1[i] = S1[i-1] + L[i-1];
		S2[i] = S2[i-1] + L[i-1] * L[i-1];
	}
	
	if(K == 2) { sub1(); }
	else if(N < 500){
		sub2();
	} else {
		sub3();
	}
	
	return 0;
}

