#include <algorithm>
#include <cmath>
#include <cstring>
#include <cstdio>
using namespace std;

//ifstream fin("atom.in");
//ofstream fout("atom.out");
struct node
{
	int l;
	int r;
	long long ma;
	long long mi;
};

const long long INF = 9999999999;
const int MAXN = 100005;
int n, m;
char q1[] = "min", q2[] = "max", mer[] = "merge", inser[] = "insert";
long long a[MAXN], s[MAXN];
node tree[MAXN * 2];

inline int lson(int id)
{
	return id * 2;
}
inline int rson(int id)
{
	return id * 2 + 1;
}
inline int mid(int a, int b)
{
	return (a + b) / 2;
}

inline void build(int id, int beg, int end)
{
	tree[id].l = beg;
	tree[id].r = end;
	if (beg == end)
	{
		tree[id].ma = a[beg];
		tree[id].mi = a[beg];
	}
	else
	{
		int m = mid(beg, end);
		build(lson(id), beg, m);
		build(rson(id), m + 1, end);
		tree[id].ma = max(tree[lson(id)].ma, tree[rson(id)].ma);
		tree[id].mi = min(tree[lson(id)].mi, tree[rson(id)].mi);
	}
	return;
}
		
inline long long qa(int id, int beg, int end)
{
	if (tree[id].r < beg || tree[id].l > end)
		return 0;
	else if (tree[id].l >= beg && tree[id].r <= end)
		return tree[id].ma;
	else 
		return max(qa(lson(id), beg, end), qa(rson(id), beg, end));
}

inline long long qi(int id, int beg, int end)
{
	if (tree[id].r < beg || tree[id].l > end)
		return INF;
	else if (tree[id].l >= beg && tree[id].r <= end)
		return tree[id].mi;
	else 
		return min(qi(lson(id), beg, end), qi(rson(id), beg, end));
}

inline long long ask(int id, int beg, int end, int cmd)
{
	if (cmd == 1)
	{
		long long ans = INF;
		for (int i = beg + 1; i < end + 1; ++i)
			ans = min(ans, s[i]);
		return ans;
	}
	else
		return qa(id, beg, end) - qi(id, beg, end);
}

inline long long read()
{
	long long x = 0;
	char c = getchar();
	while (c < '0' || c > '9')
		c = getchar();
	while (c >= '0' && c <= '9')
	{
		x = x * 10 + c - '0';
		c = getchar();
	}
	return x;
}

inline bool cmp(char a[], char b[])
{
	int size1 = strlen(a), size2 = strlen(b);
	if (size1 == size2)
	{
		for (int i = 0; i < size1; ++i)
		{
			if (a[i] != b[i])
				return false;
		}
		return true;
	}
	else
		return false;
}

long long work(int beg, int end, int cmd)
{
	switch(cmd)
	{
	case 1:
	{
		long long big = 0, small = INF;
		for (int i = beg; i < end + 1; ++i)
		{
			big = max(a[i], big);
			small = min(a[i], small);
		}
		return big - small;
		break;
	}
	case 2:
	{
		long long differ = INF;
		for (int i = beg + 1; i < end + 1; ++i)
			differ = min(s[i], differ);
		return differ;
		break;
	}
	case 3:
	{
		a[beg] = end;
		for (int i = beg + 1; i < n; ++i)
		{
			a[i] = a[i + 1];
			s[i] = abs(a[i] - a[i - 1]);
		}
		a[n] = 0;
		n--;
		return 0;
		break;
	}
	case 4:
	{
		for (int i = n + 1; i > beg + 1; --i)
			a[i] = a[i - 1];
		a[beg + 1] = end;
		n++;
		for (int i = beg; i < n + 1; ++i)
			s[i] = abs(a[i] - a[i - 1]);
		return 0;
		break;
	}
	default:
		break;
	}
}
int main()
{
	freopen("atom.in", "r", stdin);
	freopen("atom.out", "w", stdout);
	n = read();
	m = read();
	for (int i = 1; i < n + 1; ++i)
	{
		a[i] = read();
		s[i] = abs(a[i] - a[i - 1]);
	}
	if (n <= 1000)
	{	
		for (int i = 0; i < m; ++i)
		{
			int x, y;
			char t[10];
			scanf("%s", t);
			x = read(), y = read();
			if (cmp(t,q1))
				printf("%lld\n", work(x, y, 2));
			else if (cmp(t,q2))
				printf("%lld\n", work(x, y, 1));
			else if (cmp(t, mer))
				work(x, y, 3);
			else if (cmp(t, inser))
				work(x, y, 4);
		}
	}
	else
	{
		build(1, 1, n);
		for (int i = 0; i < m; ++i)
		{
			int x, y;
			char t[10];
			scanf("%s", t);
			x = read(), y = read();
			if (cmp(t,q1))
				printf("%lld\n", ask(1, x, y, 1));
			else if (cmp(t,q2))
				printf("%lld\n", ask(1, x, y, 2));
		}
	}
	fclose(stdin);
	fclose(stdout);
	return 0;
}
