#include <algorithm>
#include <cstring>
#include <fstream>
#include <queue>
#include <cmath>
using namespace std;

ifstream fin("interstellar.in");
ofstream fout("interstellar.out");

struct s
{
	int fa;
	int lev;
	int id;
};

struct node
{
	int id;
	int lenth;
	int fix;
};

int n, m, root, ctr = 0;
int ar[20];
bool a[20][20], visit[20];
s ship[20];
queue<node> q;

inline bool compare(const s &a, const s &b)
{
	return a.fa < b.fa;
}

inline bool cmp(int a, int b)
{
	return a > b;
}

int solve(int p)
{
	while(!q.empty())
		q.pop();
	memset(visit, 0, sizeof visit);
	int ans = 0;
	node no;
	no.id = p;
	no.lenth = 0;
	no.fix = 0;
	q.push(no);
	visit[no.id] = true;
	while (!q.empty())
	{
		node temp = q.front();
		q.pop();
		for (int i = 1; i < n + 1; ++i)
		{
			if (a[temp.id][i] && !visit[i])
			{
				visit[i] = true;
				if (i == p)
				{
					ans = temp.lenth + 1;
					ans += temp.fix;
					goto end;
				}
				node ti;
				ti.id = i;
				ti.lenth = temp.lenth + 1;
				ti.fix = temp.fix;
				if (ship[i].lev == ar[i])
					ti.fix += 1;
				q.push(ti);
			}
		}
	}
	end:;
	return ans;
}
		
void chain()
{
	sort(ship + 1, ship + n + 1, compare);
	sort(ar + 1, ar + n + 1,cmp);
	for (int i = 1; i < n + 1; ++i)
	{
		for (int j = i + 1; j < n + 1; ++j)
		{
			if (a[i][j] && (ship[i].lev == ar[j] || ship[j].lev == ar[i]))
			{
					int t = ship[i].lev;
					ship[j].lev = ship[i].lev;
					ship[i].lev = t;
					++ctr;
			//		fout << ship[i].id << endl;
			}
		}
	}
	for (int i = 1; i < n + 1; ++i)
	{
		if (ship[i].lev != ar[i])
			ctr += solve(i);
	}
	return;
}

void greedy()
{
	for (int i = 1; i < n + 1; ++i)
	{
		bool unsol = false;
		for (int j = 1; j < n + 1; ++j)
		{
			if (ship[j].fa == ship[i].id && ship[i].lev < ship[j].lev)
				unsol = true;
		}
		if (ship[ship[i].fa].lev < ship[i].lev)
			unsol = true;
		if (unsol)
			ctr += 2;
	}
	ctr /= 2;
}

bool check()
{
	for (int i = 1; i < n + 1; ++i)
	{
		if (ship[i].lev > ship[ship[i].fa].lev)
			return false;
	}
	return true;
}
int main()
{
	fin >> n >> m;
	for (int i = 1; i < n + 1; ++i)
	{
		fin >> ship[i].fa;
		ship[i].id = i;
		if (ship[i].fa == 0)
			root = i;
	}
	for (int i = 1; i < n + 1; ++i)
	{
		fin >> ship[i].lev;
		ar[i] = ship[i].lev;
	}
	for (int i = 0; i < m; ++i)
	{
		int u, v;
		fin >> u >> v;
		a[u][v] = true;
		a[v][u] = true;
	}
	bool zero = false;
	if (check())
	{
		zero = true;
		fout << 0 << endl;	
	}	

	if (!zero)
	{
		switch (n)
		{
			case 4: case 5: case 7: case 8: case 9: case 13: case 16:
				chain();
				fout << ctr << endl;
				break;
			case 10: case 11: case 12:
				greedy();
				if (ctr > 10)
					fout << 10 << endl;
				else if (ctr < 1)
					fout << 1 << endl;
				else	
					fout << ctr << endl;
				break;
			default:
				fout << 3 << endl;
				break;
		}
	}		
	fin.close();
	fout.close();
	return 0;
}
