#include <fstream>
#include <iostream>
#include <cmath>
#include <algorithm>
using namespace std;

ifstream fin("spaceship.in");
ofstream fout("spaceship.out");

const int MAXN = 300005;
const double EPS = 0.0000001;
int n, k;
long long a[MAXN], s[25];
int color[MAXN];
long long sum = 0;
double avg;

long long calc()
{
	long long ans = 0;
	for (int i = 1; i < k + 1; ++i)
		ans += s[i] * s[i];
	ans *= k * k;
	ans -= sum * sum * k;
	return ans;
}

inline int check(long long a, long long b, long long c)
{
	double dist1 = fabs((double)(a) - avg),
		   dist2 = fabs((double)(a + b) - avg),
		   dist3 = fabs((double)(a + b - c) - avg),
		   dist4 = fabs((double)(a - c) - avg);
	if (dist2 <= dist1 && dist2 <= dist3 && dist2 <= dist4)
		return 1;
	else if (dist1 <= dist2 && dist1 <= dist3 && dist1 <= dist4)
		return 2;
	else if (dist3 < dist1 && dist3 < dist2 && dist3 < dist4)
		return 3;
	else
		return 4;
}

inline bool getd(long long p, long long v, long long t)
{
	long long rest = p - t,
	          next = v + t;
	double dist1 = fabs((double)next - avg),
		   dist2 = fabs((double)rest - avg),
		   dist3 = fabs((double)p - avg),
		   dist4 = fabs((double)v - avg);
	return(dist1 * dist1 + dist2 * dist2) < (dist3 * dist3 + dist4 * dist4);
}
int main()
{
	fin >> n >> k;
	for (int i = 0; i < n; ++i)
	{
		fin >> a[i];		
		sum += a[i];
	}
    avg = (double)sum / (double)k;
    int mark = 0;
	for (int i = 1; i < k + 1; ++i)
	{
		long long t = 0;
		int beg = mark;
		for (int j = mark; j < n + 1; ++j)
		{
			if(j == n)
				j = 0;
			if (color[j] != 0)
			{
				if(getd(color[j], t, a[j]))
				{
					s[i - 1] -= a[j];
					t += a[j];
					color[j] = i;
				}
				else
				{
					mark = j;
					break;
				}
			}
			else if (t + a[j] > avg - EPS)
			{
				int cmd = check(t, a[j], a[beg]);
			//	fout << cmd << endl;
				switch(cmd)
				{
				case 1:
					t += a[j];
					color[j] = i;
					break;
				case 2:
					mark = j;
					goto nest;
					break;
				case 3:
				{
					int pre = beg - 1;
					if (beg == 0)
						pre = n - 1;
					if (color[pre] != 0)
					{
						if (getd(t, s[pre], a[beg]))
						{
							t -= a[beg];
							color[beg] = color[pre];	
						}
					}
					else
					{
						t -= a[beg];
						color[beg] = color[pre];
					}
					t += a[j];
					color[j] = i;
					break;
				}
				default:
					mark = j;
					goto nest;
					break;
				}
			}
			else
			{
				t += a[j];
				color[j] = i;
			}
		}
		nest:;
		s[i] = t;
	}
	fout << calc() << endl;
	fin.close();
	fout.close();
	return 0;
}
