#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cstring>

using namespace std;

const int MAXN = 1e5 + 10;
const int oo = 1e9;
int n, m, tn, a[MAXN], tot = 0;

int force_lv[MAXN*4];
int force_rv[MAXN*4];
int force_mxv[MAXN*4];
int force_mnv[MAXN*4];
int force_mnans[MAXN*4];
bool force_flag = 1;

struct query {
	string op;
	int x, y;
}q[MAXN];

inline int max(int x, int y) {
	return x < y ? y : x;
}

inline int min(int x, int y) {
	return x < y ? x : y;
}

void update(int x) {
	force_lv[x] = force_lv[x<<1];
	force_rv[x] = force_rv[x<<1|1];
	force_mxv[x] = max(force_mxv[x<<1], force_mxv[x<<1|1]);
	force_mnv[x] = min(force_mnv[x<<1], force_mnv[x<<1|1]);
	force_mnans[x] = min(min(force_mnans[x<<1], force_mnans[x<<1|1]), abs(force_rv[x<<1]-force_lv[x<<1|1]));
}

int force_getmx(int l, int r) {
	int Max = -oo, Min = oo;
	for (l+=tn-1, r+=tn+1; l^r^1; l>>=1, r>>=1) {
		if (~l & 1) {
			Max = max(Max, force_mxv[l^1]);
			Min = min(Min, force_mnv[l^1]);
		}
		if (r & 1) {
			Max = max(Max, force_mxv[r^1]);
			Min = min(Min, force_mnv[r^1]);
		}
	}
	return Max - Min;
}

int force_getmn(int l, int r) {
	int lv = -1, rv = -1, ret = oo;
	for (l+=tn-1, r+=tn+1; l^r^1; l>>=1, r>>=1) {
		if (~l & 1) {
			ret = min(ret, force_mnans[l^1]);
			if (lv != -1)
				ret = min(ret, abs(force_lv[l^1]-lv));
			lv = force_rv[l^1];
		}
		if (r & 1) {
			ret = min(ret, force_mnans[r^1]);
			if (rv != -1)
				ret = min(ret, abs(force_rv[r^1]-rv));
			rv = force_lv[r^1];
		}
	}
	return min(ret, abs(rv-lv));
}

void force() {
	for (tn = 1; tn < n + 2; tn <<= 1);
	for (int i = 1; i <= n; ++i) {
		force_lv[tn+i] = a[i];
		force_rv[tn+i] = a[i];
		force_mxv[tn+i] = a[i];
		force_mnv[tn+i] = a[i];
		force_mnans[tn+i] = oo;
	}
	for (int i = tn-1; i; --i)
		update(i);
	for (int i = 0; i < m; ++i) {
		string op = q[i].op;
		int x = q[i].x, y = q[i].y;
		if (op == "max")
			cout << force_getmx(x, y) << endl;
		else
			cout << force_getmn(x, y) << endl;
	}
	exit(0);
}

struct Node {
	int cnt, h;
	int v, lv, rv, mxv, mnv, mnans;
	Node *l, *r;
	Node() {};
	Node(int _v) {
		v = lv = rv = mxv = mnv = _v;
		mnans = oo;
		cnt = 1;
		h = rand();
		l = r = 0;
	}
}*root = 0, nodes[MAXN*40];

int get_cnt(Node* p) {
	return p ? p->cnt : 0;
}

int get_mxv(Node* p) {
	return p ? p->mxv : -oo;
}

int get_mnv(Node* p) {
	return p ? p->mnv : oo;
}

int get_mnans(Node* p) {
	return p ? p->mnans : oo;
}

void update(Node* p) {
	p->lv = p->l ? p->l->lv : p->v;
	p->rv = p->r ? p->r->rv : p->v;
	p->cnt = get_cnt(p->l) + get_cnt(p->r) + 1;
	p->mxv = max(max(get_mxv(p->l), get_mxv(p->r)), p->v);
	p->mnv = min(min(get_mnv(p->l), get_mnv(p->r)), p->v);
	p->mnans = min(get_mnans(p->l), get_mnans(p->r));
	if (p->l)
		p->mnans = min(p->mnans, abs(p->l->rv - p->v));
	if (p->r)
		p->mnans = min(p->mnans, abs(p->r->lv - p->v));
}

void insert(Node* &p, int k, int x, bool flag = 0) {
	if (!p) {
		p = &nodes[tot++];
		*p = Node(x);
		return ;
	}
	if (flag) {
		insert(p->l, k, x, flag);
		update(p);
		return ;
	}
	int t = get_cnt(p->l);
	if (k == t + 1) {
		insert(p->r, k, x, 1);
		if (p->r->h > p->h) {
			Node* t = p->r;
			p->r = t->l;
			t->l = p;
			update(p);
			p = t;
		}
	}
	else if (k <= t) {
		insert(p->l, k, x, flag);
		if (p->l->h > p->h) {
			Node* t = p->l;
			p->l = t->r;
			t->r = p;
			update(p);
			p = t;
		}
	}
	else {
		insert(p->r, k-t-1, x, flag);
		if (p->r->h > p->h) {
			Node* t = p->r;
			p->r = t->l;
			t->l = p;
			update(p);
			p = t;
		}
	}
	update(p);
}

Node* merge(Node* x, Node* y) {
	if (!x)
		return y;
	if (!y)
		return x;
	if (x->h > y->h) {
		x->r = merge(x->r, y);
		update(x);
		return x;
	}
	else {
		y->l = merge(x, y->l);
		update(y);
		return y;
	}
}

void erase(Node* &p, int k) {
	int t = get_cnt(p->l);
	if (k == t + 1) {
		p = merge(p->l, p->r);
		return ;
	}
	if (k <= t)
		erase(p->l, k);
	else
		erase(p->r, k-t-1);
	update(p);
}

Node* cut1(Node* pre, int k) {
	if (!pre)
		return 0;
	int t = get_cnt(pre->l);
	if (k < t + 1)
		return cut1(pre->l, k);
	Node* p = &nodes[tot++];
	*p = *pre;
	p->r = cut1(pre->r, k-t-1);
	update(p);
	return p;
}

Node* cut2(Node* pre, int k) {
	if (!pre)
		return 0;
	int t = get_cnt(pre->l);
	if (k > t + 1)
		return cut2(pre->r, k-t-1);
	Node* p = &nodes[tot++];
	*p = *pre;
	p->l = cut2(pre->l, k);
	update(p);
	return p;
}

void print(Node* p, char c = 'R') {
	if (!p)
		return ;
	cerr << p->v << ": type=" << c << " cnt=" << p->cnt << " lv=" << p->lv << " rv=" << p->rv
		 << " mxv=" << p->mxv << " mnv=" << p->mnv << " mnans=" << p->mnans << endl;
	print(p->l, 'l');
	print(p->r, 'r');
}

int main() {
	freopen("atom.in", "r", stdin);
	freopen("atom.out", "w", stdout);
	ios::sync_with_stdio(0);
	srand(20000802);
	cin >> n >> m;
	for (int i = 1; i <= n; ++i)
		cin >> a[i];
	for (int i = 0; i < m; ++i) {
		cin >> q[i].op >> q[i].x >> q[i].y;
		if (q[i].op == "insert" || q[i].op == "merge")
			force_flag = 0;
	}
	if (force_flag)
		force();
	for (int i = 1; i <= n; ++i)
		insert(root, i, a[i]);
//	print(root); cerr << endl;
//	cerr << "#" << endl;
	for (int i = 0; i < m; ++i) {
		string op = q[i].op;
		int x = q[i].x, y = q[i].y;
//		cerr << "$" << i << " " << op << " " << x << " " << y << " " << root->cnt << endl;
		if (op == "insert")
			insert(root, x, y);
		else if (op == "merge") {
			erase(root, x);
			insert(root, x, y);
			erase(root, x);
		}
		else {
			Node* p1 = cut1(root, y);
//			print(p1); cerr << endl;
			Node* p2 = cut2(p1, x);
//			print(p2); cerr << endl;
			if (op == "max")
				cout << p2->mxv - p2->mnv << endl;
			else
				cout << p2->mnans << endl;
		}
	}
//	cerr << 1.0*tot/MAXN << endl;
	return 0;
}
