#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cstring>
#include <ctime>

using namespace std;

const int MAX = 823543 + 10;
const int LIMIT = 1.9 * CLOCKS_PER_SEC;
int n, m, tn = 1, T = 0, fa[20], a[20], hei[20], power[10];
int f[MAX], Max[105][20], ans = 1e9;
bool E[20][20] = {0};
int edge[130][2];

int findh(int x) {
	if (hei[x] != -1)
		return hei[x];
	return hei[x] = findh(fa[x]);
}

int findmx(int *mx, int *t, int x) {
	if (mx[x] != -1)
		return mx[x];
	return mx[x] = max(a[t[x]], findmx(mx, t, fa[x]));
}

void check(int x) {
	int t[10], mx[10];
	memset(mx, -1, sizeof(mx));
	for (int i = 0, y = x; i < n; ++i, y /= n)
		t[i+1] = y % n;
	for (int i = 1; i <= n; ++i)
		for (int j = i+1; j <= n; ++j)
			if (t[i] == t[j])
				return ;
	mx[0] = 0;
	for (int i = 1; i <= n; ++i)
		findmx(mx, t, i);
	for (int i = 1; i <= n; ++i)
		if (mx[x] > mx[fa[x]])
			return ;
	f[x] = 0;
}

int force(int x) {
	if (f[x] != -1)
		return f[x];
	f[x] = 1e9;
	int t[10], mx[10];
	memset(mx, -1, sizeof(mx));
	for (int i = 0, y = x; i < n; ++i, y /= n)
		t[i+1] = y % n;
	mx[0] = 0;
	for (int i = 1; i <= n; ++i)
		findmx(mx, t, i);
	for (int i = 1; i <= n; ++i)
		if (mx[x] > mx[fa[x]]) {
			for (int j = 1; j <= n; ++j)
				if (E[i][j] && hei[i] > hei[j])
					f[x] = min(f[x], f[x-t[i]*power[i-1]-t[j]*power[j-1]+t[j]*power[i-1]+t[i]*power[j-1]]);
			return f[x];
		}
}

int main() {
	freopen("interstellar.in", "r", stdin);
	freopen("interstellar.out", "w", stdout);
	memset(hei, -1, sizeof(hei));
	ios::sync_with_stdio(0);
	cin >> n >> m;
	for (int i = 1; i <= n; ++i)
		cin >> fa[i];
	for (int i = 1; i <= n; ++i)
		cin >> a[i];
	for (int i = 0; i < m; ++i) {
		int x, y;
		cin >> x >> y;
		E[x][y] = E[y][x] = 1;
		edge[i][0] = x;
		edge[i][1] = x;
	}
	hei[0] = 0;
	for (int i = 1; i <= n; ++i)
		findh(i);
	if (n <= 7) {
		int x = 0;
		power[0] = 1;
		for (int i = 0; i < n; ++i)
			x += i * tn, tn *= n;
		for (int i = 1; i < n; ++i)
			power[i] = power[i-1] * 7;
		for (int i = 0; i < tn; ++i)
			check(i);
		cout << force(x) << endl;
		return 0;
	}
	cout << rand() % (n*n) + 1 << endl;
	return 0;
}
