#include <cstdio>
#include <algorithm>
#include <cmath>
using namespace std;

#define iter(i, n) for (int i = 1; i <= n; ++i)
#define iter0(i, n) for (int i = 0; i < n; ++i)
#define forw(i, a, b) for (int i = a; i <= b; ++i)
#define back(i, a, b) for (int i = b; i >= a; --i) 

int cur_rand = 19981214;
int my_rand() {
	return cur_rand = (1214ll * cur_rand + 8991) % 1000000007;
}

#define u t[x]
#define o t[y]
#define lc ch[0]
#define rc ch[1]
#define tc ch[d]
#define vc ch[!d]
#define ulfc t[u.lc]
#define urtc t[u.rc]

const int inf = 1e9;

struct Info { int max, min, ms; };

Info merge(const Info& a, const Info& b) {
	return (Info) { max(a.max, b.max), min(a.min, b.min), max(max(a.ms, b.ms), max(abs(a.max - b.min), abs(a.min - b.max))) };
}

struct Tr {
	int ch[2], pri, sz;
	int ns; Info ms;
	int val, d;
	
	void set(int _w, int _d) {
		val = _w, d = _d;
		pri = my_rand();
	}
} t[501000];

int root, tsz;

void upd(int x) {
	if (x == 0) return;
	Info tmp = (Info) { u.val, u.val, 0 };
	
	if (u.lc == 0 && u.rc == 0) {
		u.ms = tmp;
		u.ns = u.d;
	} else if (u.lc == 0) {
		u.ms = merge(tmp, urtc.ms);
		u.ns = min(urtc.ns, u.d);
	} else if (u.rc == 0) {
		u.ms = merge(ulfc.ms, tmp);
		u.ns = min(ulfc.ns, u.d);
	} else {
		u.ms = merge(merge(ulfc.ms, tmp), urtc.ms);
		u.ns = min(min(ulfc.ns, urtc.ns), u.d);
	}
	u.sz = ulfc.sz + urtc.sz + 1;
}

void rot(int &x, bool d) { int y = u.tc; u.tc = o.vc, o.vc = x; upd(x), upd(x = y); }

int kth(int k) {
	for (int x = root; ;) {
		if (k == ulfc.sz + 1) return x;
		else if (k <= ulfc.sz) x = u.lc;
		else k -= ulfc.sz + 1, x = u.rc;
	}
}

void modify(int x, int k, int w, int r) {
	if (k == ulfc.sz + 1) {
		if (w != -1) u.val = w;
		if (r != -1) u.d = abs(u.val - r);
		
		upd(x);
		return;
	}
	
	if (k <= ulfc.sz) modify(u.lc, k, w, r);
	else modify(u.rc, k - ulfc.sz - 1, w, r);
	upd(x);
}

void ins(int &x, int k, int _w, int _d) {
	if (x == 0) {
		x = ++tsz;
		u.set(_w, _d);
		upd(x);
		return;
	}
	
	bool d = k > ulfc.sz;
	if (k <= ulfc.sz) ins(u.lc, k, _w, _d);
	else ins(u.rc, k - ulfc.sz - 1, _w, _d);
	
	if (t[u.tc].pri > u.pri) rot(x, d);
	else upd(x);
}

void del(int &x, int k) {
	if (k == ulfc.sz + 1) {
		bool d = urtc.pri > ulfc.pri;
		if (u.tc == 0) {
			x = 0;
			return;
		} else {
			int y = x;
			rot(x, d);
			del(u.vc, t[o.lc].sz + 1);
		}
	} else {
		if (k <= ulfc.sz) del(u.lc, k);
		else del(u.rc, k - ulfc.sz - 1);
	}
	upd(x);
}

Info ask_max(int x, int l, int r) {
	if (l <= 1 && u.sz <= r) return u.ms;
	int k = ulfc.sz + 1;
	
	if (l <= k && k <= r) {
		bool el = (l < k && u.lc != 0), er = (r > k && u.rc != 0);
		Info tmp = (Info) { u.val, u.val, 0 };
		
		if (!el && !er) return tmp;
		else if (!el) return merge(tmp, ask_max(u.rc, l - k, r - k));
		else if (!er) return merge(ask_max(u.lc, l, r), tmp);
		else return merge(merge(ask_max(u.lc, l, r), tmp), ask_max(u.rc, l - k, r - k));
	} else {
		if (r < k) return ask_max(u.lc, l, r);
		else return ask_max(u.rc, l - k, r - k);
	}
}

int ask_min(int x, int l, int r) {
	if (l <= 1 && u.sz <= r) return u.ns;
	
	int k = ulfc.sz + 1, res = +inf;
	if (l <= k && k <= r) res = u.d;
	
	if (l < k && u.lc != 0) res = min(res, ask_min(u.lc, l, r));
	if (k < r && u.rc != 0) res = min(res, ask_min(u.rc, l - k, r - k));
	
	return res;
}

int n, m;

int main() {
	freopen("atom.in", "r", stdin);
	freopen("atom.out", "w", stdout);
	
	scanf("%d%d", &n, &m);
	int lst, len = n;
	//!!!process 0
	t[0].ns = +inf;
	
	iter(i, n) {
		int tmp;
		scanf("%d", &tmp);
		ins(root, i - 1, tmp, i == 1 ? -1 : abs(lst - tmp));
		lst = tmp;
	}
	iter(i, m) {
		char op[20]; int p, w;
		scanf("%s%d%d", op, &p, &w);
		if (op[0] == 'i') {
			int x = kth(p);
			if (p < len) modify(root, p + 1, -1, w);
			ins(root, p, w, abs(u.val - w));
			++len;
		} else if (op[1] == 'e') {
			del(root, p + 1);
			modify(root, p, w, p == 1 ? -1 : t[kth(p - 1)].val);
			--len;
			if (p < len) modify(root, p + 1, -1, w);
		} else {
			if (op[1] == 'a') printf("%d\n", ask_max(root, p, w).ms);
			else printf("%d\n", ask_min(root, p + 1, w));
		}
	}
	return 0;
}

