#include <cstdio>
#include <vector>
#include <map>
#include <queue>
#include <algorithm>
using namespace std;

#define iter(i, n) for (int i = 1; i <= n; ++i)
#define iter0(i, n) for (int i = 0; i < n; ++i)
#define forw(i, a, b) for (int i = a; i <= b; ++i)
#define back(i, a, b) for (int i = b; i >= a; --i) 

#define NR 200

map<vector<int>, int> dist;
queue<vector<int> > q;
int n, m, fa[NR], x[NR], y[NR];

bool valid(vector<int> w) {
	iter(i, n) if (fa[i] != 0 && w[i] > w[fa[i]]) return false;
	return true; 
}

int main() {
	freopen("interstellar.in", "r", stdin);
	freopen("interstellar.out", "w", stdout);
	scanf("%d%d", &n, &m);
	
	iter(i, n) scanf("%d", &fa[i]);
	vector<int> init;
	init.resize(n + 1);
	iter(i, n) scanf("%d", &init[i]);
	iter(i, m) scanf("%d%d", &x[i], &y[i]);

	q.push(init);
	
	while (!q.empty()) {
		vector<int> cur = q.front();
		q.pop();
		
		int d = dist[cur];
		
		if (valid(cur)) {
			printf("%d\n", d);
			return 0;
		}
		
		iter(i, m) {
			swap(cur[x[i]], cur[y[i]]);
			
			if (valid(cur)) {
				printf("%d\n", d + 1);
				return 0;
			}
			
			if (dist.find(cur) == dist.end()) {
				q.push(cur);
				dist[cur] = d + 1;
			}
			
			swap(cur[x[i]], cur[y[i]]);
		}
	}
	return 0;
}
