#include <cstdio>
#include <iostream>
using namespace std;

#define iter(i, n) for (int i = 1; i <= n; ++i)
#define iter0(i, n) for (int i = 0; i < n; ++i)
#define forw(i, a, b) for (int i = a; i <= b; ++i)
#define back(i, a, b) for (int i = b; i >= a; --i) 

typedef long long i64;

int n, K;

inline i64 sqr(i64 a) { return a * a; }

namespace S1 {

const int NR = 900;
const int KR = 30;
i64 f[NR][KR];
int a[NR];
i64 sum[NR];


void solve(int k, int l, int r, int L, int R) {
	if (l > r) return;
	int mid = (l + r) / 2;
	int p = mid - 1;
	forw(i, L, R) if (i < mid && f[i][k - 1] + sqr(sum[mid] - sum[i]) < f[mid][k]) {
		f[mid][k] = f[i][k - 1] + sqr(sum[mid] - sum[i]);
		p = i;
	}
	solve(k, l, mid - 1, L, p);
	solve(k, mid + 1, r, p, R);
}

void solve1() {
	iter(i, n) {
		scanf("%d", &a[i]);
		a[n + i] = a[i];
	}
	int N = 2 * n;
	iter(i, N) sum[i] = sum[i - 1] + a[i];
	
	i64 res = 1e18;
	
	iter0(s, n) {
		forw(i, 0, N) forw(j, 0, K) f[i][j] = 1e18;
		f[s][0] = 0;
		iter(i, K) solve(i, s + 1, s + n, s, s + n);
		res = min(res, f[s + n][K]);
	}
	
	cout << K * K * res - K * sqr(sum[n]) << endl;
	
}
}

void solve2() {
	const int NR = 201000;
	
	static int a[NR];
	static i64 sum[NR];
	
	iter(i, n) {
		scanf("%d", &a[i]);
		a[n + i] = a[i];
	}
	int N = 2 * n;
	iter(i, N) sum[i] = sum[i - 1] + a[i];
	
	i64 res = 1e18;
	
	int j = 1;
	
	iter(i, n) {
		if (j < i) j = i;
		while (j < i + n && 
			sqr(sum[j + 1] - sum[i]) + sqr(sum[i + n] - sum[j + 1]) <
			sqr(sum[j] - sum[i]) + sqr(sum[i + n] - sum[j])
			) ++j;
			
		res = min(res, sqr(sum[j] - sum[i]) + sqr(sum[i + n] - sum[j]));
	}
	
	
	cout << K * K * res - K * sqr(sum[n]) << endl;
}

namespace S3 {

const int NR = 601000;
	
int a[NR];
i64 sum[NR];

i64 bin(int L, int R) {
	int l = L + 1, r = R;
	
	for (; l < r; ) {
		int i = (l + r) / 2;
		
		if (sqr(sum[R] - sum[i + 1]) + sqr(sum[i + 1] - sum[L]) < 
			sqr(sum[R] - sum[i]) + sqr(sum[i] - sum[L]))
			l = i + 1;
		else r = i;
	}
	
	return sqr(sum[R] - sum[l]) + sqr(sum[l] - sum[L]);
}

void solve3() {
	iter(i, n) {
		scanf("%d", &a[i]);
		a[n + i] = a[i];
	}
	int N = 2 * n;
	iter(i, N) sum[i] = sum[i - 1] + a[i];
	
	i64 res = 1e18;
	
	int j = 1;
	
	iter(i, n) {
		if (j < i) j = i;
		while (j + 1 < i + n && 
			sqr(sum[j + 1] - sum[i]) + bin(j + 1, i + n) <
			sqr(sum[j] - sum[i]) + bin(j, i + n)
			) ++j;
			
		res = min(res, sqr(sum[j] - sum[i]) + bin(j, i + n));
	}
	
	cout << K * K * res - K * sqr(sum[n]) << endl;
}

}

int main() {
	freopen("spaceship.in", "r", stdin);
	freopen("spaceship.out", "w", stdout);
	
	scanf("%d%d", &n, &K);
	
	if (K == 2) solve2();
	else if (K == 3) S3::solve3();
	else S1::solve1();	
	
	return 0;
}
