#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <algorithm>
#include <map>
#include <vector>
#include <utility>

using namespace std;

typedef pair<int, int> P;

const int MAXH = 105;
const int MAXN = 25;
const int MAXM = 125;

int a[MAXN], R[MAXN], F[MAXN], pos[MAXN], X[MAXN], Y[MAXN];

bool use[MAXN];

int n, m, depth = 0;

void init() {
	memset(use, 0, sizeof(use));
	for (int i = 1; i <= n; i++)
		use[R[i]] = 1;
	int tmp = n, cur = -1;
	for (int i = 1; i <= n; i++)
		if (!use[i])
			cur = i;
	while (cur != 0) {
		pos[cur] = tmp--;
		cur = R[cur];
	}
	for (int i = 1; i <= m; i++) {
		X[i] = pos[X[i]];
		Y[i] = pos[Y[i]];
	}
	for (int i = 1; i <= n; i++)
		a[pos[i]] = F[i];
	sort(F + 1, F + n + 1);
	reverse(F + 1, F + n + 1);
}

int getExp() {
	int cnt = 0;
	for (int i = 1; i <= n; i++)
		if (a[i] != F[i])
			cnt++;
	return (cnt + 1) / 2;
}

int check() {
	int cnt = 0;
	for (int i = 1; i <= n; i++) {
		for (int j = R[i]; j != 0; j = R[j]) {
			if (F[i] > F[j]) {
				cnt++;
				break;
			}
		}
	}
	return cnt;
}

bool search(int h, int x) {
	if (h + x > depth)
		return 0;
	if (x == 0)
		return 1;
	P seq[MAXM];
	for (int i = 1; i <= m; i++) {
		swap(a[X[i]], a[Y[i]]);
		int p = getExp();
		seq[i] = P(p, i);
		swap(a[X[i]], a[Y[i]]);
	}
	sort(seq + 1, seq + m + 1);
	reverse(seq + 1, seq + m + 1);
	for (int i = 1; i <= m; i++) {
		int j = seq[i].second, v = seq[i].first;
		swap(a[X[j]], a[Y[j]]);
		if (search(h + 1, v))
			return 1;
		swap(a[X[j]], a[Y[j]]);
	}
	return 0;
}

bool search2(int h) {
	if (h > depth)
		return 0;
	int x = check();
	if (x == 0)
		return 1;
	for (int i = 1; i <= m; i++) {
		swap(F[X[i]], F[Y[i]]);
		if (search2(h + 1))
			return 1;
		swap(F[X[i]], F[Y[i]]);
	}
	return 0;
}

int main() {
	ios::sync_with_stdio(false);
	freopen("interstellar.in", "r", stdin);
	freopen("interstellar.out", "w", stdout);
	cin >> n >> m;
	for (int i = 1; i <= n; i++)
		cin >> R[i];
	for (int i = 1; i <= n; i++)
		cin >> F[i];
	for (int i = 1; i <= m; i++)
		cin >> X[i] >> Y[i];
	if (n > 7) {
		init();
		int v = getExp();
		depth = v;
		while (!search(0, v))
			depth++;
		cout << depth << endl;
	}
	else {
		depth = 0;
		while (!search2(0))
			depth++;
		cout << depth << endl;
	}
	return 0;
}

