
// Copyright (C) 2000-2017  Geoffrey "jeffswt" Tang.
//
// This file is part of the BJOI-WC solutions.  This program is free
// software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the
// Free Software Foundation; either version 3, or (at your option)
// any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// Potentially passing 40% data.

#include <iostream>
#include <cstdlib>
#include <cstdio>

#define SWTAPI inline
#define rep(_var,_begin,_end) for(int _var=_begin;_var<=_end;_var++)
#define range(_begin,_end) rep(_,_begin,_end)
#define sqr(_in) ((_in)*(_in))
using namespace std;
typedef long long lli;
const int maxn = 300010, maxk = 30;
const lli infinit = 0x007f7f7f7f7f7f7fll;

int n, K;
lli l[maxn], a_sum[maxn], a_sum_2[maxn];
lli dp[maxn][maxk];

SWTAPI lli sum(int l, int r) {
    return a_sum[r] - a_sum[l - 1]; }
SWTAPI lli sum_2(int l, int r) {
    return a_sum_2[r] - a_sum_2[l - 1]; }

SWTAPI lli work_subtask(void)
{
    // Finished reading data, Preprocessing sums.
    a_sum[0] = 0;
    a_sum_2[0] = 0;
    for (int i = 1; i <= n; i++) {
        a_sum[i] = a_sum[i - 1] + l[i];
        a_sum_2[i] = a_sum_2[i - 1] + l[i] * l[i];
    }
    // Clearing dynamic programming array.
    dp[0][0] = 0;
    range(1, K) dp[0][_] = infinit;
    // Set initial parameters
    lli const_sum = sum(1, n);
    for (int i = 1; i <= n; i++) {
        range(0, K) dp[i][_] = infinit;
        // Considering the implications of the previous state
        for (int j = 0; j < i; j++) {
            // Managing to sort out the levels
            for (int k = 1; k <= K; k++) {
                lli new_state =
                    dp[j][k - 1] +
                    K*K * sqr(sum(j + 1, i));
                if (new_state < dp[i][k])
                    dp[i][k] = new_state;
                continue;
            }
        }
    }
    // Returning result.
    lli res = dp[n][K];
    res -= K * sqr(const_sum);
    return res;
}

int main(int argc, char** argv)
{
    freopen("spaceship.in", "r", stdin);
    freopen("spaceship.out", "w", stdout);
    scanf("%d%d", &n, &K);
    for (int i = 1; i <= n; i++)
        scanf("%lld", &l[i]);
    // Running n times, from n individual beginning points
    lli res = infinit;
    for (int i = 1; i <= n; i++) {
        lli t_res = work_subtask();
        res = min(res, t_res);
//        printf("%d -> %lld\n", i, t_res);
        for (int j = 1; j <= n; j++)
            l[j - 1] = l[j];
        l[n] = l[0];
        l[0] = 0;
    }
    // Finished, now outputting result.
    printf("%lld\n", res);
    return 0;
}

