#include <iostream>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <queue>
#include <vector>

using namespace std;

const int N = 100000 + 5, INF = 1e9;
typedef long long LL;

int n, m, E[N];
char str[10];

void init()
{
	scanf("%d%d", &n, &m);
	for (int i = 1; i <= n; i ++)
		scanf("%d", &E[i]);
}

int next[N], cnt;

void baoli()
{
	cnt = n;
	for (int i = 1; i < n; i ++)
		next[i] = i + 1;
	for (int i = 1; i <= m; i ++)
	{
		int a, b;
		scanf("%s%d%d", str, &a, &b);
		//printf("%c\n", str[1]);
		int p = 1, k = 1;
		while (k < a) p = next[p], k ++;
		if (str[1] == 'e'){
			next[p] = next[next[p]];
			E[p] = b;
		}
		if (str[1] == 'n'){
			cnt ++;
			next[cnt] = next[p];
			next[p] = cnt;
			E[cnt] = b;
		}
		if (str[1] == 'a'){
			int MIN = INF, MAX = 0;
			while (k <= b) MIN = min(MIN, E[p]), MAX = max(MAX, E[p]), p = next[p], k ++;
			printf("%d\n", MAX - MIN);
		}
		if (str[1] == 'i'){
			int ans = INF;
			while (k < b) ans = min(ans, abs(E[p]-E[next[p]])), p = next[p], k ++;
			printf("%d\n", ans);
		}
	}
}

struct TREE{
	int ans, MAX, MIN;
}tree[N << 2];

#define ls u << 1
#define rs u << 1 | 1

void build(int u, int l, int r)
{
	if (l == r) { 
		tree[u].ans = INF;
		tree[u].MAX = tree[u].MIN = E[l];
		return ;
	}
	int mid = (l + r) >> 1;
	build(ls, l, mid); build(rs, mid + 1, r);
	tree[u].MAX = max(tree[ls].MAX, tree[rs].MAX);
	tree[u].MIN = min(tree[ls].MIN, tree[rs].MIN);
	tree[u].ans = min(abs(E[mid]-E[mid+1]), min(tree[ls].ans, tree[rs].ans));
}

void query1(int u, int l, int r, int ql, int qr, int &MAX, int &MIN)
{
	//cout << l << ' ' << r << endl;
	if (ql <= l && qr >= r) {
		MAX = max(MAX, tree[u].MAX);
		MIN = min(MIN, tree[u].MIN);
		return ;
	}
	int mid = (l + r) >> 1, k = 0;
	if (ql <= mid) query1(ls, l, mid, ql, qr, MAX, MIN);
	if (qr > mid) query1(rs, mid + 1, r, ql, qr, MAX, MIN);
	return ;
}

int query2(int u, int l, int r, int ql, int qr)
{
	if (ql <= l && qr >= r) return tree[u].ans;
	int mid = (l + r) >> 1, k = INF;
	if (ql <= mid) k = query2(ls, l, mid, ql, qr);
	if (qr > mid) k = min(k, query2(rs, mid + 1, r, ql, qr));
	if (ql <= mid && qr > mid) k = min(k, abs(E[mid]-E[mid+1]));
	return k;
}

void work()
{
	build(1, 1, n);
	for (int i = 1; i <= m; i ++)
	{
		int a, b;
		scanf("%s%d%d", str, &a, &b);
		if (str[1] == 'a')
		{
			int MAX = 0, MIN = INF;
			query1(1, 1, n, a, b, MAX, MIN);
			printf("%d\n", MAX - MIN);
		}
		else if (str[1] == 'i')
			printf("%d\n", query2(1, 1, n, a, b));
	}
}

int main()
{
	freopen("atom.in", "r", stdin);
	freopen("atom.out", "w", stdout);
	init();
	if (n < 10000) baoli();
	else work();
	return 0;
}
/*
4 3
5 8 10 2
max 1 3
min 1 3
max 2 4

6 7
3 1 5 2 6 4
max 1 3 
max 2 4
max 2 6
min 2 4
max 4 6
min 1 6
min 2 5

*/
