#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cstring>
#include <string>
#include <algorithm>

using namespace std;

int n, m;

struct ex {
	int min;
	int max;
	int lc;
	int rc;
	int lcnt;
	int rcnt;
	int cnt;
};

ex tree[4000005];
int ec = 0;

int a[5005];
int b[5005];

int read(){
	int x;
	scanf("%d", &x);
	return x;
}

int update(int x, int num, int enow){
	
	int mid = tree[enow].lcnt;
	
	if(x == 1 and tree[enow].cnt == 1){
		tree[enow].min = num;
		tree[enow].max = num;
		return 0;
	}
	
	if(x <= mid){
		update(x, num, tree[enow].lc);
		tree[enow].max = max(tree[tree[enow].lc].max, tree[tree[enow].rc].max);
		tree[enow].min = min(tree[tree[enow].lc].min, tree[tree[enow].rc].min);
	}else{
		update(x - mid, num, tree[enow].rc);
		tree[enow].max = max(tree[tree[enow].lc].max, tree[tree[enow].rc].max);
		tree[enow].min = min(tree[tree[enow].lc].min, tree[tree[enow].rc].min);
	}
	
	return 0;
}

int deletep(int x, int enow){
	
	int mid = tree[enow].lcnt;
	
	tree[enow].cnt--;
	
	if(x == 1 and tree[enow].cnt == 0){
		tree[enow].cnt = 0;
		return 0;
	}
	
	if(x <= mid){
		deletep(x, tree[enow].lc);
		tree[enow].lcnt = tree[tree[enow].lc].cnt;
		if(tree[enow].lcnt == 0){
			tree[enow].max = tree[tree[enow].rc].max;
			tree[enow].min = tree[tree[enow].rc].min;
		}else{
			tree[enow].max = max(tree[tree[enow].lc].max, tree[tree[enow].rc].max);
			tree[enow].min = min(tree[tree[enow].lc].min, tree[tree[enow].rc].min);
		}
	}else{
		deletep(x - mid, tree[enow].rc);
		tree[enow].rcnt = tree[tree[enow].rc].cnt;
		if(tree[enow].rcnt == 0){
			tree[enow].max = tree[tree[enow].lc].max;
			tree[enow].min = tree[tree[enow].lc].min;
		}else{
			tree[enow].max = max(tree[tree[enow].lc].max, tree[tree[enow].rc].max);
			tree[enow].min = min(tree[tree[enow].lc].min, tree[tree[enow].rc].min);
		}
	}
	
	return 0;
}

int insert(int x, int num, int enow){
	
	int mid = tree[enow].lcnt;
	
	
	
	if(x == 1 and tree[enow].cnt == 1){
		tree[enow].cnt++;
		ec++;
		tree[enow].lc = ec;
		tree[ec].min = tree[enow].min;
		tree[ec].max = tree[enow].max;
		tree[ec].cnt = 1;
		ec++;
		tree[enow].rc = ec;
		tree[ec].min = num;
		tree[ec].max = num;
		tree[ec].cnt = 1;
		tree[enow].max = max(tree[tree[enow].lc].max, tree[tree[enow].rc].max);
		tree[enow].min = min(tree[tree[enow].lc].min, tree[tree[enow].rc].min);
		tree[enow].lcnt = tree[tree[enow].lc].cnt;
		tree[enow].rcnt = tree[tree[enow].rc].cnt;
		return 0;
	}
	
	tree[enow].cnt++;
	
	if(x <= mid){
		insert(x, num, tree[enow].lc);
		tree[enow].max = max(tree[tree[enow].lc].max, tree[tree[enow].rc].max);
		tree[enow].min = min(tree[tree[enow].lc].min, tree[tree[enow].rc].min);
		tree[enow].lcnt = tree[tree[enow].lc].cnt;
	}else{
		insert(x - mid, num, tree[enow].rc);
		tree[enow].max = max(tree[tree[enow].lc].max, tree[tree[enow].rc].max);
		tree[enow].min = min(tree[tree[enow].lc].min, tree[tree[enow].rc].min);
		tree[enow].rcnt = tree[tree[enow].rc].cnt;
	}
	
	return 0;
}

int querymax(int x, int y, int enow){
	
	int mid = tree[enow].lcnt;
	
	if(x == 1 and y == tree[enow].cnt){
		return tree[enow].max;
	}
	
	if(y <= mid){
		return querymax(x, y, tree[enow].lc);
	}else if(x > mid){
		return querymax(x - mid, y - mid, tree[enow].rc);
	}else{
		return max(querymax(x, mid, tree[enow].lc), querymax(1, y - mid, tree[enow].rc));
	}
	
	return 0;
}

int querymin(int x, int y, int enow){
	
	int mid = tree[enow].lcnt;
	
	if(x == 1 and y == tree[enow].cnt){
		return tree[enow].min;
	}
	
	if(y <= mid){
		return querymin(x, y, tree[enow].lc);
	}else if(x > mid){
		return querymin(x - mid, y - mid, tree[enow].rc);
	}else{
		return min(querymin(x, mid, tree[enow].lc), querymin(1, y - mid, tree[enow].rc));
	}
	
	return 0;
}

int getnum(int x, int enow){
	int mid = tree[enow].lcnt;
	
	if(x == 1 and tree[enow].cnt == 1){
		return tree[enow].min;
	}
	
	if(x <= mid){
		return getnum(x, tree[enow].lc);
	}else if(x > mid){
		return getnum(x - mid, tree[enow].rc);
	}
	
	return 0;
}

int inittree(int x){
	int enow;
	int mid = x / 2;
	
	ec++;
	enow = ec;
	tree[enow].cnt = x;
	
	if(x == 1){
		cin >> tree[enow].min;
		tree[enow].max = tree[enow].min;
		return enow;
	}
	
	tree[enow].lc = inittree(mid);
	tree[enow].rc = inittree(x - mid);
	
	tree[enow].max = max(tree[tree[enow].lc].max, tree[tree[enow].rc].max);
	tree[enow].min = min(tree[tree[enow].lc].min, tree[tree[enow].rc].min);
	tree[enow].lcnt = tree[tree[enow].lc].cnt;
	tree[enow].rcnt = tree[tree[enow].rc].cnt;
	
	return enow;
}

int main(){
	
	freopen("atom.in", "r", stdin);
	freopen("atom.out", "w", stdout);
	
	int i, j;
	
	int x, y;
	int e;
	string op;
	int maxn, minn;
	
	cin >> n >> m;
	
	if(n <= 1000){
		
		for(i=1;i<=n;i++){
			cin >> a[i];
		}
		
		for(i=1;i<=m;i++){
			cin >> op;
			
			if(op == "max"){
				cin >> x >> y;
				maxn = a[x];
				minn = a[x];
				for(j=x+1;j<=y;j++){
					maxn = max(maxn, a[j]);
					minn = min(minn, a[j]);
				}
				cout << maxn - minn << endl;
			}else if(op == "min"){
				cin >> x >> y;
				for(j=x;j<=y;j++){
					b[j] = a[j];
				}
				sort(b + x, b + y + 1);
				minn = b[x + 1] - b[x];
				for(j=x+2;j<=y;j++){
					minn = min(minn, b[j] - b[j - 1]);
				}
				cout << minn << endl;
			}else if(op == "insert"){
				cin >> x >> e;
				for(j=n+1;j>x+1;j--){
					a[j] = a[j - 1];
				}
				a[x + 1] = e;
				n++;
			}else if(op == "merge"){
				cin >> x >> e;
				for(j=x+1;j<n;j++){
					a[j] = a[j + 1];
				}
				a[x] = e;
			}
		}
		
	}else{
	
		inittree(n);
	
		for(i=1;i<=m;i++){
			cin >> op;
			
			
			if(op == "max"){
				cin >> x >> y;
				cout << querymax(x, y, 1) - querymin(x, y, 1) << endl;
			}else if(op == "min"){
				cin >> x >> y;
				for(j=x;j<=y;j++){
					b[j] = getnum(j, 1);
				}
				sort(b + x, b + y + 1);
				minn = b[x + 1] - b[x];
				for(j=x+2;j<=y;j++){
					minn = min(minn, b[j] - b[j - 1]);
				}
				cout << minn << endl;
			}else if(op == "insert"){
				cin >> x >> e;
				insert(x, e, 1);
			}else if(op == "merge"){
				cin >> x >> e;
				update(x, e, 1);
				deletep(x + 1, 1);
			}
		}
	}
	
	fclose(stdin);
	fclose(stdout);
	
	return 0;
}
