#include <iostream>//60
#include <cmath>

using namespace std;

struct Node
{
	int st, ed, dv, maxv, minv;
	Node *l, *r;
	Node () {}
	Node (int a, int b, int c, Node *L, Node *R, int ss, int ee)
	{
		dv = a, maxv = b, minv = c, l = L, r = R, st = ss, ed = ee;
	}
}*root;

int n, m, a[100005];

void update (Node* x)
{
	x -> dv = min (x -> l -> dv, x -> r -> dv);
	x -> maxv = max (x -> l -> maxv, x -> r -> maxv);
	x -> minv = min (x -> l-> minv, x -> r -> minv);
}

Node *build (int l, int r)
{
	if (l == r)
		return new Node (abs(a[l+1] - a[l]), a[l], a[l], 0, 0, l, r);
	int mid = (l + r) >> 1;
	Node *ret = new Node (1e9, -1e9, 2e9, build (l, mid), build (mid+1, r), l, r);
	update (ret);
	return ret;
}

int findmax (Node *x, int st, int ed)
{
	if (x -> st >= st && x -> ed <= ed)
		return x -> maxv;
	int mid = (x -> st + x -> ed) >> 1, ret = -1e9;
	if (st <= mid)
		ret = max (ret, findmax (x -> l, st, ed));
	if (ed > mid)
		ret = max (ret, findmax (x -> r, st, ed));
	return ret;
}

int findmin (Node *x, int st, int ed)
{
	if (x -> st >= st && x -> ed <= ed)
		return x -> minv;
	int mid = (x -> st + x -> ed) >> 1, ret = 1e9;
	if (st <= mid)
		ret = min (ret, findmin (x -> l, st, ed));
	if (ed > mid)
		ret = min (ret, findmin (x -> r, st, ed));
	return ret;
}

int finddv (Node *x, int st, int ed)
{
	if (x -> st >= st && x -> ed <= ed)
		return x -> dv;
	int mid = (x -> st + x -> ed) >> 1, ret = 2e9;
	if (st <= mid)
		ret = min (ret, finddv (x -> l, st, ed));
	if (ed > mid)
		ret = min (ret, finddv (x -> r, st, ed));
	return ret;
}

int main ()
{
	freopen ("atom.in", "r", stdin);
	freopen ("atom.out", "w", stdout);
	ios::sync_with_stdio (0);
	cin >> n >> m;
	for (int i = 1; i <= n; ++i)
		cin >> a[i];
	root = build (1, n);
	while (m--)
	{
		string op;
		int x, y;
		cin >> op >> x >> y;
		if (op == "insert" || op == "merge")
			continue ;
		if (op == "max")
		{
			int a = findmax (root, x, y), b = findmin (root, x, y);
			cout << a - b << endl;
		}
		else
			cout << finddv (root, x, y-1) << endl;
	}
	return 0;
}
