#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
using namespace std;

#define min(a,b) a<b?a:b
#define max(a,b) a>b?a:b
const int INF=0x7fffffff;
int N,M,len;
int MIN,MAX,DMIN;
int d[100010],dif[100010];
struct command
{
    char str[7];
    int S,E;
}c[100010];
struct tree
{
    int l,r;
    int max,min,dmin;
}t[300010];

void Construct()
{
    len=1;
    while(len<N) len*=2;
    for(int i=len;i<len+N;i++)
    {
	    t[i].l=t[i].r=i-len+1;
	    t[i].min=t[i].max=d[i-len+1];
	    t[i].dmin=dif[i-len+1];
	}
	for(int i=len+N;i<2*len;i++)
	{
	    t[i].l=t[i].r=i-len+1;
	    t[i].dmin=t[i].min=INF;
	}
	for(int i=len-1;i>=1;i--)
	{
	    t[i].l=t[2*i].l;t[i].r=t[2*i+1].r;
	    t[i].min=min(t[2*i].min,t[2*i+1].min);
	    t[i].max=max(t[2*i].max,t[2*i+1].max);
	    t[i].dmin=min(t[2*i].dmin,t[2*i+1].dmin);
	}
}
int Query_min(int id,int S,int E)
{
    if(t[id].l==S&&t[id].r==E) return t[id].min;
    if(t[2*id].r>=E) return Query_min(2*id,S,E);
    if(t[2*id+1].l<=S) return Query_min(2*id+1,S,E);
    return min(Query_min(2*id,S,t[2*id].r),
	           Query_min(2*id+1,t[2*id+1].l,E));
}
int Query_max(int id,int S,int E)
{
    if(t[id].l==S&&t[id].r==E) return t[id].max;
    if(t[2*id].r>=E) return Query_max(2*id,S,E);
    if(t[2*id+1].l<=S) return Query_max(2*id+1,S,E);
    return max(Query_max(2*id,S,t[2*id].r),
	           Query_max(2*id+1,t[2*id+1].l,E));
}
int Query_diff(int id,int S,int E)
{
    if(t[id].l==S&&t[id].r==E) return t[id].dmin;
    if(t[2*id].r>=E) return Query_diff(2*id,S,E);
    if(t[2*id+1].l<=S) return Query_diff(2*id+1,S,E);
    return min(Query_diff(2*id,S,t[2*id].r),
	           Query_diff(2*id+1,t[2*id+1].l,E));
}
int main()
{
	bool flag=true;
	freopen("atom.in","r",stdin);
	freopen("atom.out","w",stdout);
	scanf("%d%d",&N,&M);
	for(int i=1;i<=N;i++)
	{ 
	    scanf("%d",&d[i]);
	    dif[i]=abs(d[i]-d[i-1]);
    }
    dif[1]=INF;
    Construct();
    for(int i=1;i<=M;i++)
    {
	    scanf("%s",c[i].str);
	    scanf("%d%d",&c[i].S,&c[i].E);
	    getchar();
	    if(c[i].str[1]=='e'||c[i].str[1]=='n') flag=false;
	}
	if(flag)
	{
	    for(int i=1;i<=M;i++)
	    {
		    if(c[i].str[1]=='a')
		        printf("%d\n",Query_max(1,c[i].S,c[i].E)
				             -Query_min(1,c[i].S,c[i].E));
		    if(c[i].str[1]=='i')
		    printf("%d\n",Query_diff(1,c[i].S+1,c[i].E));
		}
		return 0;
	}
	else
	{
	    for(int i=1;i<=M;i++)
	    {
		    if(c[i].str[1]=='e')
		    {
			    for(int j=c[i].S+1;j<N;j++) d[j]=d[j+1];
			    N--;d[c[i].S]=c[i].E;
			}
			if(c[i].str[1]=='n')
			{
			    for(int j=N;j>c[i].S;j--) d[j+1]=d[j];
			    d[c[i].S+1]=c[i].E;N++;
			}
			if(c[i].str[1]=='a')
			{
				MAX=MIN=d[c[i].S];
		        for(int j=c[i].S+1;j<=c[i].E;j++)
		        {
				    MIN=min(MIN,d[j]);
				    MAX=max(MAX,d[j]);
				}
				printf("%d\n",MAX-MIN);
			}
			if(c[i].str[1]=='i')
		    {
			    DMIN=INF;
			    for(int j=c[i].S+1;j<=c[i].E;j++) 
				    DMIN=min(DMIN,abs(d[j]-d[j-1]));
			    printf("%d\n",DMIN);
			}
		}
	}
	return 0;
}
