#include <algorithm>
#include <fstream>
#include <vector>
using namespace std;
typedef long long LL;
ifstream cin("atom.in");
ofstream cout("atom.out");
string comm;
size_t x, y;
LL e;
size_t n, m;

struct Atom
{
	vector<LL> I;

	void merge(const size_t &x, const LL &e)
	{
		I.erase(I.begin() + x);
		I[x - 1] = e;
	}

	void insert(const size_t &x, const LL &e)
	{ I.insert(I.begin() + x, e); }

	LL max(const size_t &x, const size_t &y)
	{
		LL ma = -1e18;
		for (vector<LL>::iterator ita = I.begin() + x; ita <= I.begin() + y; ++ita)
			for (vector<LL>::iterator itb = ita + 1; itb <= I.begin() + y; ++itb)
				ma = ::max(ma, *max_element(ita, itb + 1) - *min_element(ita, itb + 1));
		return ma;
	}

	LL min(const size_t &x, const size_t &y)
	{
		LL mi = 1e18;
		for (vector<LL>::iterator ita = I.begin() + x; ita <= I.begin() + y; ++ita)
			for (vector<LL>::iterator itb = ita + 1; itb <= I.begin() + y; ++itb)
				mi = ::min(mi, *max_element(ita, itb + 1) - *min_element(ita, itb + 1));
		return mi;
	}
} at;

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	cin >> n >> m;
	at.I.reserve(n + m + 2);
	at.I.resize(n);
	for (vector<LL>::iterator it = at.I.begin(); it != at.I.end(); ++it)
		cin >> *it;
	while (m--)
	{
		cin >> comm;
		if (comm == "merge")
		{
			cin >> x >> e;
			at.merge(x, e);
		}
		else if (comm == "insert")
		{
			cin >> x >> e;
			at.insert(x, e);
		}
		else if (comm == "max")
		{
			cin >> x >> y;
			--x, --y;
			cout << at.max(x, y) << endl;
		}
		else if (comm == "min")
		{
			cin >> x >> y;
			--x, --y;
			cout << at.min(x, y) << endl;
		}
	}
	return 0;
}