#include <ctime>
#include <cstdlib>
#include <cstring>
#include <fstream>
#include <algorithm>
using namespace std;
ifstream cin("interstellar.in");
ofstream cout("interstellar.out");
size_t n, m, fa[20], in1, in2;
int dis[20][20], sorted[20], ori[20], ans;

inline bool isEqual()
{
	for (size_t i = 0; i < n; ++i)
		if (sorted[i] != ori[i])
			return false;
	return true;
}

inline void floyd()
{
	for (size_t k = 1; k <= n; ++k)
		for (size_t i = 1; i <= n; ++i)
			for (size_t j = 1; j <= n; ++j)
				if (dis[i][k] != -1 && dis[k][j] != -1 && (dis[i][j] == -1 || dis[i][j] > dis[i][k] + dis[k][j]))
					dis[i][j] = dis[i][k] + dis[k][j];
}

inline size_t findpos(const int &ne)
{ return find(sorted + 1, sorted + n + 1, ne) - sorted; }

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	srand(time(NULL));
	cin >> n >> m;
	memset(dis, -1, sizeof dis);
	for (size_t i = 1; i <= n; ++i)
	{
		dis[i][i] = 0;
		cin >> fa[i];
	}
	for (size_t i = 1; i <= n; ++i)
	{
		cin >> ori[i];
		sorted[i] = ori[i];
	}
	sort(sorted + 1, sorted + n + 1, greater<int>());
	for (size_t i = 0; i < m; ++i)
	{
		cin >> in1 >> in2;
		dis[in1][in2] = dis[in2][in1] = 1;
	}
	floyd();
	while (!isEqual())
	{
		const size_t &r = rand() % n + 1; // me
		const size_t &e = findpos(ori[r]); // me pos
		if (e == r) continue;
		const size_t &k = findpos(ori[e]); // occu me pos
		if (dis[e][k] < dis[r][k]) continue;
		swap(ori[r], ori[e]);
		ans += dis[r][e];
	}
	cout << ans << endl;
	return 0;
}
