#include <iostream>
#include <cstdio>
#include <cmath>
#include <string>

#define oo 2147483647

using namespace std;

const int MAXN=1e5+5;

typedef struct Node{
	int st, ed;
	int mx, mn;        //qujian mn, mx
	int lf, rt;
	int near;           //nearby mn
	Node*lch, *rch;
} *pnode;

int n, m;

int e[MAXN];

pnode set(int left, int right)
{
	if (left == right)
	{
		pnode r=new Node;
		r->st=r->ed=left;
		r->lch=r->rch=0;
		r->mx=r->mn=r->lf=r->rt=e[left];
		r->near=oo;
		return r;
	}
	else
	{
		pnode r=new Node;
		r->st=left;
		r->ed=right;
		int mid=(left+right)/2;
		r->lch=set(left, mid);
		r->rch=set(mid+1, right);
		pnode lch=r->lch, rch=r->rch;
		r->mn=min(lch->mn, rch->mn);
		r->mx=max(lch->mx, rch->mx);
		int tmp=min(lch->near, rch->near);
		r->near=min(tmp, abs(lch->rt - rch->lf));
		r->lf=lch->lf;
		r->rt=rch->rt;
		return r;
	}
}

int mmx=0, mmn=oo;

void findMax(pnode r, int a, int b)
{
	int st=r->st, ed=r->ed;
	if (a <= st && b >= ed)
	{
		mmx=max(mmx, r->mx);
		mmn=min(mmn, r->mn);
		return;
	}
	if (a <= r->lch->ed)
		findMax(r->lch, a, b);
	if (b >= r->rch->st)
		findMax(r->rch, a, b);
}

int nico=oo;

void findA(pnode r, int a, int b)
{
	int st=r->st, ed=r->ed;
	if (a <= st && b >= ed)
	{
		int poi=r->near;
		if (a != st)
		{
			poi=min(poi, abs(e[st]-e[st-1]));
		}
		nico=min(nico, poi);	
		return;
	}
	if (a <= r->lch->ed)
		findA(r->lch, a, b);
	if (b >= r->rch->st)
		findA(r->rch, a, b);
}

pnode root=0;

string s1="max";
		
int main()
{
	freopen("atom.in", "r", stdin);
	freopen("atom.out", "w", stdout);
	ios::sync_with_stdio(false);
	cin >> n >> m;
	for (int i=1; i<=n; ++i)
		cin >> e[i];
	root=set(1, n);
	for (int i=1; i<=m; ++i)
	{
		string x;
		int l, r;
		cin >> x >> l >> r;
		if (x == s1)
		{
			findMax(root, l, r);
			cout << mmx-mmn << endl;
			mmx=0;
			mmn=oo;
		}
		else
		{
			findA(root, l, r);
			cout << nico << endl;
			nico=oo;
		}
	}

	return 0;
}


