#include<iostream>
#include<algorithm>
#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<string>
#define ll long long
using namespace std;
const int MAXN=1e5+10;
struct node{
	int st,ed,maxs,mins,ds;
	int ls,rs;
	node *l,*r;
}*root;
int n,m,e[MAXN*2];
void update(node *ret)
{
	ret->st=ret->l->st;
	ret->ed=ret->r->ed;
	ret->ls=ret->l->ls;
	ret->rs=ret->r->rs;
	ret->maxs=max(ret->l->maxs,ret->r->maxs);
	ret->mins=min(ret->l->mins,ret->r->mins);
	ret->ds=min(ret->l->ds,ret->r->ds);
	ret->ds=min(ret->ds,abs(ret->l->rs-ret->r->ls));
}
node *build(int st,int ed)
{
	node *ret=new node;
	ret->st=st;
	ret->ed=ed;
	if(st==ed)
	{
		ret->l=ret->r=0;
		ret->ls=ret->rs=ret->maxs=ret->mins=e[st];
		ret->ds=1e9;
		return ret;
	}
	int mid=(st+ed)/2;
	ret->l=build(st,mid);
	ret->r=build(mid+1,ed);
	update(ret);
	return ret;
}
node *merge(node *lch,node *rch)
{
	node *ret=new node;
	ret->l=lch;
	ret->r=rch;
	update(ret);
	return ret;
}
node *find(int st,int ed,node *now)
{
	if(now->st==st&&now->ed==ed)
		return now;
	int mid=(now->st+now->ed)/2;
	if(ed<=mid) return find(st,ed,now->l);
	else if(st>mid) return find(st,ed,now->r);
	else return merge(find(st,mid,now->l),find(mid+1,ed,now->r));
}
struct node1{
	int st,len,maxs,mins,ds;
	int ls,rs,lazyup,lazydown;
	node1 *l,*r;
}*root1;
void update1(node1 *ret)
{
	ret->st=ret->l->st;
	ret->len=ret->l->len+ret->r->len;
	ret->ls=ret->l->ls;
	ret->rs=ret->r->rs;
	ret->maxs=max(ret->l->maxs,ret->r->maxs);
	ret->mins=min(ret->l->mins,ret->r->mins);
	ret->ds=min(ret->l->ds,ret->r->ds);
	ret->ds=min(ret->ds,abs(ret->l->rs-ret->r->ls));
	if(ret->l->lazyup)
	{
		ret->r->st+=ret->l->lazyup;
		ret->lazyup+=ret->l->lazyup;
		ret->r->lazydown+=ret->l->lazyup;
		ret->l->lazyup=0;
	}
	if(ret->r->lazyup)
	{
		ret->lazyup+=ret->r->lazyup;
		ret->r->lazyup=0;
	}
}
node1 *build1(int st,int ed)
{
	node1 *ret=new node1;
	ret->st=st;
	ret->len=ed-st+1;
	ret->lazyup=ret->lazydown=0;
	if(st==ed)
	{
		ret->l=ret->r=0;
		ret->ls=ret->rs=ret->maxs=ret->mins=e[st];
		ret->ds=1e9;
		return ret;
	}
	int mid=(st+ed)/2;
	ret->l=build1(st,mid);
	ret->r=build1(mid+1,ed);
	update1(ret);
	return ret;
}
void down(node1 *now)
{
	now->l->st+=now->lazydown;
	now->r->st+=now->lazydown;
	now->l->lazydown+=now->lazydown;
	now->r->lazydown+=now->lazydown;
	now->lazydown=0;
}
node1 *merge1(node1 *lch,node1 *rch)
{
//	cerr<<"------"<<endl;
//	cerr<<lch->st<<"->"<<(lch->st+lch->len-1)<<endl;
//	cerr<<lch->mins<<" "<<lch->maxs<<" "<<lch->ls<<" "<<lch->rs<<" "<<lch->ds<<endl;
//	cerr<<rch->st<<"->"<<(rch->st+rch->len-1)<<endl;
//	cerr<<rch->mins<<" "<<rch->maxs<<" "<<rch->ls<<" "<<rch->rs<<" "<<rch->ds<<endl;
//	cerr<<"------"<<endl;
	node1 *ret=new node1;
	ret->l=lch;
	ret->r=rch;
	update1(ret);
	return ret;
}
void insert(int x,int y,node1 *now)
{
//	cerr<<"^^^ "<<now->st<<" "<<(now->st+now->len-1)<<" "<<now->len<<endl;
	if(now->len==1)
	{
		now->len++;
		now->rs=y;
		now->maxs=max(now->maxs,y);
		now->mins=min(now->mins,y);
		now->ds=abs(y-now->ls);
		now->lazyup++;
		now->l=new node1;
		now->l->st=now->st;
		now->l->len=1;
		now->l->ls=now->l->rs=now->l->maxs=now->l->mins=now->ls;
		now->l->ds=1e9;
		now->l->lazydown=now->l->lazyup=0;
		now->r=new node1;
		now->r->st=now->st+1;
		now->r->len=1;
		now->r->ls=now->r->rs=now->r->maxs=now->r->mins=now->rs;
		now->r->ds=1e9;
		now->r->lazydown=now->r->lazyup=0;
		return;
	}
	if(now->lazydown) down(now);
	int tmped=now->st+now->len-1;
	int mid=now->r->st-1;
	if(x<=mid) insert(x,y,now->l);
	else insert(x,y,now->r);
	update1(now);
//	cerr<<"^^ "<<now->st<<" "<<(now->st+now->len-1)<<" "<<now->len<<endl;
}
node1 *find1(int st,int ed,node1 *now)
{
//	cerr<<st<<" "<<ed<<endl;
//	cerr<<"**  "<<now->st<<" "<<(now->st+now->len-1)<<endl;
	if(now->len==(ed-st+1))
		return now;
	down(now);
	int mid=now->r->st-1;
	if(ed<=mid) return find1(st,ed,now->l);
	else if(st>mid) return find1(st,ed,now->r);
	else return merge1(find1(st,mid,now->l),find1(mid+1,ed,now->r));
}
string a[MAXN];
int b[MAXN],c[MAXN];
bool check1()
{
	for(int i=1;i<=m;++i)
		if(a[i]=="merge"||a[i]=="insert")
			return 0;
	return 1;
}
int main()
{
	ios::sync_with_stdio(0);
	freopen("atom.in","r",stdin);
	freopen("atom.out","w",stdout);
	cin>>n>>m;
	for(int i=1;i<=n;++i)
		cin>>e[i];
	for(int i=1;i<=m;++i)
		cin>>a[i]>>b[i]>>c[i];
	if(n<=1010)
	{
		for(int k=1;k<=m;++k)
		{
			if(a[k]=="merge")
			{
				e[b[k]]=c[k];
				for(int i=b[k]+1;i<=n;++i)
					e[i]=e[i+1];
				n--;
			}
			else if(a[k]=="insert")
			{
				for(int i=n;i>b[k];--i)
					e[i+1]=e[i];
				e[b[k]+1]=c[k];
				n++;
			}
			else if(a[k]=="max")
			{
				int Max=0,Min=1e9;
				for(int i=b[k];i<=c[k];++i)
					Max=max(e[i],Max),Min=min(e[i],Min);
				cout<<Max-Min<<endl;
			}
			else 
			{
				int ans=1e9;
				for(int i=b[k];i<c[k];++i)
					ans=min(ans,abs(e[i+1]-e[i]));
				cout<<ans<<endl;
			}
		}
	}
	else if(check1())
	{
		root=build(1,n);
		for(int k=1;k<=m;++k)
		{
			node *ans=find(b[k],c[k],root);
			if(a[k]=="max") cout<<(ans->maxs-ans->mins)<<endl;
			else cout<<ans->ds<<endl;
		}
	}
	else
	{
		root1=build1(1,n);
		for(int k=1;k<=m;++k)
		{
//			cerr<<a[k]<<" "<<b[k]<<" "<<c[k]<<endl;
//			cerr<<" ##"<<root1->len<<endl;
			if(a[k]=="merge") continue;
			else if(a[k]=="insert") insert(b[k],c[k],root1);
			else 
			{
				node1 *ans=find1(b[k],c[k],root1);
//				cerr<<"!!! "<<ans->ls<<" "<<ans->mins<<" "<<ans->maxs<<endl;
				if(a[k]=="max") cout<<(ans->maxs-ans->mins)<<endl;
				else cout<<ans->ds<<endl;
			}
		}
	}
	return 0;
}
