#include <iostream>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <set>
#include <cmath>

using namespace std;

const int INF = 1000000000;
const int MAXN = 200010;

struct Query {
	bool type;
	int l, r, num;
}q[MAXN];

bool cmp1 (const Query &a, const Query &b) {
	return a.l != b.l ? a.l < b.l : a.r < b.r;
}

bool cmp2 (const Query &a, const Query &b) {
	return a.r != b.r ? a.r < b.r : a.l < b.l;
}

int a[MAXN];
int ans[MAXN];
multiset <int > S;
int mx, mi;
int n, m;

namespace Force {
	int Max (int x, int y) {
		int mx = 0, mi = INF;
		for (int i = x; i <= y; i++) {
			mx = max(mx, a[i]);
			mi = min(mi, a[i]);
		}
		return mx - mi;
	}
	
	int Min (int x, int y) {
		S.clear();
		S.insert(a[x]);
		int ret = INF;
		for (int i = x + 1; i <= y; i++) {
			set <int > :: iterator it = S.lower_bound(a[i]);
			if (it != S.end())
				ret = min(ret, *it - a[i]);
			if (it != S.begin()) {
				it--;
				ret = min(ret, a[i] - *it);
			}
			S.insert(a[i]);
		}
		return ret;
	}
	
	void insert (int x, int v) {
		for (int i = n; i > x; i--)
			a[i + 1] = a[i];
		a[x + 1] = v;
		n++;
	}
	
	void merge (int x, int v) {
		a[x] = v;
		n--;
		for (int i = x + 1; i <= n; i++)
			a[i] = a[i + 1];
	}
	
	void main () {
		char op[32];
		for (int i = 1; i <= m; i++) {
			int x, y;
			scanf("%s %d %d", op, &x, &y);
			switch (op[1]) {
				case 'e':
					merge(x, y);
					break;
				case 'n':
					insert(x, y);
					break;
				case 'a':
					printf("%d\n", Max(x, y));
					break;
				case 'i':
					printf("%d\n", Min(x, y));
					break;	
			}
		}
	}
}

void add (int x, int &mx, int &mi) {
	if (!S.empty()) {
		mx = max(mx, max(abs(x - *S.begin()), abs(x - *S.rbegin())));
		set <int > :: iterator it = S.lower_bound(x);
		if (it != S.end())
			mi = min(mi, *it - x);
		if (it != S.begin()) {
			it--;
			mi = min(mi, x - *it);
		}
	}
	S.insert(x);
}

int main () {
	freopen("atom.in", "r", stdin);
	freopen("atom.out", "w", stdout);
	scanf("%d %d", &n, &m);
	for (int i = 1; i <= n; i++)
		scanf("%d", &a[i]);
	if (n <= 1000) {
		Force :: main();
		return 0;
	}
	char op[32];
	for (int i = 1; i <= m; i++) {
		scanf("%s %d %d", op, &q[i].l, &q[i].r);
		if (op[1] == 'a')
			q[i].type = 1;
		q[i].num = i;
	}
	int M = sqrt(n);
	sort(q + 1, q + m + 1, cmp1);
	for (int i = 1; i <= m; ) {
		int j = i;
		while (j < m && q[j + 1].l - q[i].l < M)
			j++;
		int L = q[j].l;
		sort(q + i, q + j + 1, cmp2);
		while (i <= j && q[i].r < L) {
			S.clear();
			mx = 0, mi = INF;
			for (int k = q[i].l; k <= q[i].r; k++)
				add(a[k], mx, mi);
			ans[q[i].num] = q[i].type ? mx : mi;
			i++;
		}
		int R = L - 1, Mx = 0, Mi = INF;
		S.clear();
		while (i <= j) {
			for (int k = R + 1; k <= q[i].r; k++)
				add(a[k], Mx, Mi);
			R = q[i].r;
			mx = Mx;
			mi = Mi;
			for (int k = L - 1; k >= q[i].l; k--)
				add(a[k], mx, mi);
			for (int k = L - 1; k >= q[i].l; k--)
				S.erase(S.find(a[k]));
			ans[q[i].num] = q[i].type ? mx : mi;
			i++;
		}
	}
	for (int i = 1; i <= m; i++)
		printf("%d\n", ans[i]);
		
	
	return 0;
}
