#include <iostream>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <queue>

using namespace std;

const int MOD = 321547;

int f[32], r[32];
int n, m;
int x[32], y[32];

int hash (const int *f) {
	int ret = 0;
	for (int i = 1; i <= n; i++)
		ret = (10 * ret + f[i]) % MOD;
	return ret;
}

struct State {
	int f[17], s;
	void set (int *F) {
		for (int i = 1; i <= n; i++)
			f[i] = F[i];
	}
	bool check () {
		for (int i = 1; i <= n; i++)
			if (r[i] != 0 && f[i] > f[r[i]])
				return false;
		return true;
	}
};

struct Hashtable {
	int f[17];
	int next;
}has[1000000];

int h[MOD + 1], tot;
queue <State > q;

void push (const State &x) {
	int v = hash(x.f);
	for (int i = h[v]; i; i = has[i].next) {
		bool ok = true;
		for (int j = 1; j <= n; j++)
			if (has[i].f[j] != x.f[j]) {
				ok = false;
				break;
			}
		if (ok)
			return;
	}
	has[++tot].next = h[v];
	h[v] = tot;
	for (int j = 1; j <= n; j++)
		has[tot].f[j] = x.f[j];
	q.push(x);
}

int bfs () {
	State st;
	st.set(f);
	st.s = 0;
	q.push(st);
	while (!q.empty()) {
		State cur = q.front();
		if (tot > 600000) {
			cout << cur.s << endl;
			exit(0);
		}
		q.pop();
		if (cur.check())
			return cur.s;
		for (int i = 1; i <= m; i++) {
			State next;
			next.set(cur.f);
			next.s = cur.s + 1;
			swap(next.f[x[i]], next.f[y[i]]);
			push(next);
		}
	}
}

int main () {
	freopen("intersteller.in", "r", stdin);
	freopen("intersteller.out", "w", stdout);
	cin >> n >> m;
	for (int i = 1; i <= n; i++)
		cin >> r[i];
	for (int i = 1; i <= n; i++)
		cin >> f[i];
	for (int i = 1; i <= m; i++)
		cin >> x[i] >> y[i];
	cout << bfs() << endl;
	
	return 0;
}
