#include <iostream>
#include <cstdio>
#include <cmath>
using namespace std;

int a[200010], b[2010];
const int oo = 1e9 + 7;

struct Node {
	int al, ar, Min, Max, minus;
} node[400010];

void update(Node &now, Node l, Node r) {
	now.Max = max(l.Max, r.Max);
	now.Min = min(l.Min, r.Min);
	now.al = l.al;
	now.ar = r.ar;
	int tmp = abs(l.ar - r.al);
	now.minus = min(min(l.minus, r.minus), tmp);
}

void buildtree(int x, int st, int ed) {
	if(st == ed)
	{
		node[x].al = node[x].ar = node[x].Min = node[x].Max = a[st];
		node[x].minus = oo;
		return;
	}
	int mid = (st + ed) / 2;
	buildtree(2 * x, st, mid);
	buildtree(2 * x + 1, mid + 1, ed);
	update(node[x], node[2 * x], node[2 * x + 1]);
}

Node get_ans(int x, int l, int r, int st, int ed) {
	if(st <= l && ed >= r)
		return node[x];
	int mid = (l + r) / 2;
	if(ed <= mid)
		return get_ans(2 * x, l, mid, st, ed);
	else if(st > mid)
		return get_ans(2 * x + 1, mid + 1, r, st, ed);
	Node tmp1 = get_ans(2 * x, l, mid, st, mid);
	Node tmp2 = get_ans(2 * x + 1, mid + 1, r, mid + 1, ed);
	Node tmp;
	update(tmp, tmp1, tmp2);
	return tmp;
}

int main() {
	freopen("atom.in", "r", stdin);
	freopen("atom.out", "w", stdout);
	int n, m;
	cin >> n >> m;
	for(int i = 1; i <= n; ++i)
		cin >> a[i];
	if(n <= 1000)
	{
		for(int i = 1; i < n; ++i)
			b[i] = abs(a[i + 1] - a[i]);
		for(int i = 1; i <= m; ++i)
		{
			string s;
			cin >> s;
			if(s == "max")
			{
				int l, r;
				cin >> l >> r;
				int Max = 0, Min = oo;
				for(int j = l; j <= r; ++j)
				{
					if(Max < a[j])
						Max = a[j];
					if(Min > a[j])
						Min = a[j];
				}
				cout << Max - Min << endl;	
			}
			if(s == "min")
			{
				int l, r;
				cin >> l >> r;
				int ans = oo;
				for(int j = l; j < r; ++j)
					if(ans > b[j])
						ans = b[j];
				cout << ans << endl;
			}
			if(s == "insert")
			{
				int x, e;
				cin >> x >> e;
				for(int j = n; j > x; --j)
					a[j + 1] = a[j];
				a[x + 1] = e;
				++n;
				for(int j = x; j < n; ++j)
					b[j] = abs(a[j + 1] - a[j]);
			}
			if(s == "merge")
			{
				int x, e;
				cin >> x >> e;
				--n;
				for(int j = x + 1; j <= n; ++j)
					a[j] = a[j + 1];
				a[x] = e;
				for(int j = x; j < n; ++j)
					b[j] = abs(a[j + 1] - a[j]);
			}
		}
		return 0;
	}
	buildtree(1, 1, n);
	cout << "&&&" << endl;
	for(int i = 1; i <= m; ++i)
	{
		string s;
		cin >> s;
		if(s == "max")
		{
			int l, r;
			cin >> l >> r;
			Node tmp = get_ans(1, 1, n, l, r);
			cout << tmp.Max - tmp.Min << endl;	
		}
		if(s == "min")
		{
			int l, r;
			cin >> l >> r;
			Node tmp = get_ans(1, 1, n, l, r);
			cout << tmp.minus << endl;
		}
		if(s == "insert")
		{
			int x, e;
			cin >> x >> e;
		}
		if(s == "merge")
		{
			int x, e;
			cin >> x >> e;
		}		
	}
	return 0;
}
