#include <fstream>
#include <cstdlib>
#include <cstring>
#include <algorithm>
#include <string>
using namespace std;
ifstream cin("atom.in");
ofstream cout("atom.out");

const int maxn = 100001;
int n, m, a[maxn];
int tree_min[maxn * 3], tree_max[maxn * 3];


void build_tree_min(int node, int l, int r)
{
	if(l == r)
	{
		tree_min[node] = a[l];
		return;
	}
	int mid = (l+r) >> 1;
	build_tree_min((node << 1), l, mid);
	build_tree_min((node << 1) + 1, mid+1, r);
	tree_min[node] = min(tree_min[node << 1], tree_min[(node << 1) + 1]);
}

int query_tree_min(int node, int l, int r, int x, int y)
{
	if(l == x && r == y)
		return tree_min[node];
	int mid = (l+r) >> 1;
	if(y <= mid) // L X Y MID R
		return query_tree_min(node << 1, l, mid, x, y);
	if(x > mid) // L MID X Y R
		return query_tree_min((node << 1) + 1, mid+1, r, x, y);
	// L X MID Y R
	return min(query_tree_min(node << 1, l, mid, x, mid), query_tree_min((node << 1) + 1, mid+1, r, mid+1, y));
}

int subseq_min(int x, int y)
{
	int ans = query_tree_min(1, 1, n, x, y);
	//cout << "subseq_min(" << x << "," << y << ")=" << ans << endl;
	return ans;
}

void build_tree_max(int node, int l, int r)
{
	if(l == r)
	{
		tree_max[node] = a[l];
		return;
	}
	int mid = (l+r) >> 1;
	build_tree_max((node << 1), l, mid);
	build_tree_max((node << 1) + 1, mid+1, r);
	tree_max[node] = max(tree_max[node << 1], tree_max[(node << 1) + 1]);
}

int query_tree_max(int node, int l, int r, int x, int y)
{
	if(l == x && r == y)
		return tree_max[node];
	int mid = (l+r) >> 1;
	if(y <= mid) // L X Y MID R
		return query_tree_max(node << 1, l, mid, x, y);
	if(x > mid) // L MID X Y R
		return query_tree_max((node << 1) + 1, mid+1, r, x, y);
	// L X MID Y R
	return max(query_tree_max(node << 1, l, mid, x, mid), query_tree_max((node << 1) + 1, mid+1, r, mid+1, y));
}

int subseq_max(int x, int y)
{
	int ans = query_tree_max(1, 1, n, x, y);
	//cout << "subseq_max(" << x << "," << y << ")=" << ans << endl;
	return ans;
}

int query_f_min(int x, int y)
{
	int i, j, ans = 2147483647;
	for(i = x; i < y; i++)
		for(j = i+1; j <= y; j++)
			ans = min(ans, subseq_max(i, j) - subseq_min(i, j));
	return ans;
}

int query_f_max(int x, int y)
{
	int i, j, ans = 0;
	for(i = x; i < y; i++)
		for(j = i+1; j <= y; j++)
			ans = max(ans, subseq_max(i, j) - subseq_min(i, j));
	return ans;
}

int main()
{
	cin >> n >> m;
	int i, x, y;
	for(i = 1; i <= n; i++)
		cin >> a[i];
	build_tree_min(1, 1, n);
	build_tree_max(1, 1, n);
	char command[16];
	for(i = 1; i <= m; i++)
	{
		cin >> command >> x >> y;    
		if(strcmp(command, "min") == 0)
		{
			cout << query_f_min(x, y) << endl;
		}
		else if(strcmp(command, "max") == 0)
		{
			cout << query_f_max(x, y) << endl;
		}
	}
	return 0;
}

