#include <iostream>
#include <cmath>
#include <cstdlib>
#include <cstdio>
#include <fstream>
#include <algorithm>
#include <queue>

using namespace std;
class tree
{
public:
	
	int left_tree_i;
	int right_tree_i;
	
	tree * left_tree;
	tree * right_tree;
	
	int n, f;
	tree * space_p;
	
	tree(int _n = 0, int _f = 0, int treeL = 0, int treeR = 0)
	{
		n = _n;
		f = _f;
		setTreeL(treeL);
		setTreeR(treeR);
	}
	
	void setTreeL(int treeL)
	{
		left_tree_i = treeL;
		left_tree = getTree(treeL);
	}
	
	void setTreeR(int treeR)
	{
		right_tree_i = treeR;
		right_tree = getTree(treeR);
	}
	
	tree * getTree(int p)
	{
		return &(space_p[p]);
	}
	
	static tree * createTree()
	{
		tree * newSpace = new tree[50];
		for(int i = 1; i < 50; i++)
		{
		    newSpace[i].space_p = newSpace;
		    newSpace[i].n = i;
		    newSpace[i].left_tree = NULL;
		    newSpace[i].left_tree_i = 0;
		    newSpace[i].right_tree = NULL;
		    newSpace[i].right_tree_i = 0;
		    
		}
		return &newSpace[1];
	}
	
	tree * copyTree()
	{
		tree * newSpace = new tree[50];
		for(int i = 1; i < 50; i++)
		{
		    newSpace[i].space_p = newSpace;
		    newSpace[i].f = getTree(i) -> f;
		    if(getTree(i) -> left_tree != NULL)
		        newSpace[i].setTreeL(getTree(i) -> left_tree_i);
		    if(getTree(i) -> left_tree != NULL)
		        newSpace[i].setTreeR(getTree(i) -> right_tree_i);
		    newSpace[i].n = i;
		}
		return &newSpace[n];
	}
};

class link
{
public:
	int to_p;
	link * next;
	link(int _to_p = 0, link * _next = NULL)
	{
		to_p = _to_p;
		next = _next;
	}
};

tree * Tree;
int N, M;
link * _f[50];
class ctree
{
public:
	tree * t;
	int c;
	ctree(tree * _t = 0, int _c = 0)
	{
		t = _t;
		c = _c;
	}
	ctree operator ()(tree * _t, int _c)
	{
		t = _t;
		c = _c;
		return *this;
	}
};

bool chk(tree * p)
{
	if(p == NULL) return true;
	if(p -> left_tree != NULL && (p -> f) < (p -> left_tree -> f))
	    return false;
	if(p -> right_tree != NULL && (p -> f) < (p -> right_tree -> f))
	    return false;
	return chk(p -> left_tree) && chk(p -> right_tree);
}

queue<ctree> q;

int main()
{
	freopen("interstellar.in", "r", stdin);
	freopen("interstellar.out", "w", stdout);
	Tree = tree::createTree();
	scanf("%d %d", &N, &M);
	for(int i = 1; i <= N; i++)
	{
		int tmp;
		scanf("%d", &tmp);
		if(tmp)
		{
			if((Tree -> getTree(tmp) -> left_tree) == NULL)
			    Tree -> getTree(tmp) -> setTreeL(i);
			else
			    Tree -> getTree(tmp) -> setTreeR(i);
		}
		else Tree = (Tree -> getTree(i));
	}
	
	for(int i = 1; i <= N; i++)
	{
		int tmp;
		scanf("%d", &tmp);
		Tree -> getTree(i) -> f = tmp;
	}
	
	for(int i = 1; i <= M; i++)
	{
		int tmp1, tmp2;
		scanf("%d %d", &tmp1, &tmp2);
		_f[tmp1] = new link(tmp2, _f[tmp1]);
		// _f[tmp2] = new link(tmp1, _f[tmp2]);
	}
	q.push(ctree(Tree, 0));
	while(q.size())
	{
		tree * p = q.front().t;
		int pc = q.front().c;
		q.pop();
		if(chk(p)) { printf("%d", pc); return 0; }
		for(int i = 1; i <= N; i++)
		{
			link * p1 = _f[i];
			while(p1 != NULL)
			{
				tree * newTree = p -> copyTree();
				int ss1 = newTree -> getTree(i) -> f;
				newTree -> getTree(i) -> f = newTree -> getTree(p1 -> to_p) -> f;
				newTree -> getTree(p1 -> to_p) -> f = ss1;
				q.push(ctree(newTree, pc + 1));
				p1 = p1 -> next;
			}
		}
	}
}
