#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>

using namespace std;
struct Node
{
	int mi,st,ed,ma;
	Node *r,*l;
}*root1,*root2;
int n,m,a[101010],aa,bb,cnt = 0,eps;
char ord[101];

void build1(Node *&now,int st,int ed)
{
	now = new Node;
	now->st = st;
	now->ed = ed;
	if (st == ed)
	{
		now->mi = now->ma = a[st];
		now->r = now->l = NULL;
		return ;
	}
	build1(now->l,st,(st+ed)/2);
	build1(now->r,(st+ed)/2+1,ed);
	now->mi = min(now->l->mi,now->r->mi);
	now->ma = max(now->l->ma,now->r->ma);
}

void build2(Node *&now,int st,int ed)
{
	now = new Node;
	now->st = st;
	now->ed = ed;
	if (st == ed)
	{
		now->mi = abs(a[st+1]-a[st]);
		now->l = now->r = NULL;
		return ;
	}
	build2(now->l,st,(st+ed)/2);
	build2(now->r,(st+ed)/2+1,ed);
	now->mi = min(now->l->mi,now->r->mi);
}

int getmin(Node *now,int st,int ed)
{
	if (now->st > ed || now->ed < st)
		return 2147483644;
	if (now->st >= st && now->ed <= ed)
		return now->mi;
	return min(getmin(now->l,st,ed),getmin(now->r,st,ed));
}

int getmax(Node *now,int st,int ed)
{
	if (now->st > ed || now->ed < st)
		return 0;
	if (now->st >= st && now->ed <= ed)
		return now->ma;
	return max(getmax(now->l,st,ed),getmax(now->r,st,ed));
}

int findtyp()
{
	if (n <= 1000)
		return 1;
	if (m == 50000)
		return 3;
	return 2;
}

int l[606],bi[606],si[606],di[606],tot;
int map[606][606];
inline void makeblocks()
{
	tot = 0;
	int len = sqrt(1.0*n);
	for (int i = 1;i < n; i += len)
	{
		l[++tot] = len;
		bi[tot] = 0;
		di[tot] = si[tot] = 2147483644;
		for (int j = i;j <= i+len-1; j++)
		{
			bi[tot] = max(bi[tot],a[j]);
			si[tot] = min(si[tot],a[j]);
			di[tot] = min(di[tot],abs(a[j]-a[j-1]));
			map[tot][j-i+1] = a[j];
		}
	}
	if (tot*len < n)
	{
		l[tot+1] = n-tot*len;
		bi[tot+1] = 0;
		di[tot+1] = si[tot+1] = 2147483644;
		for (int j = tot*len+1;j <= n; j++)
		{
			bi[tot+1] = max(bi[tot],a[j]);
			si[tot+1] = min(si[tot],a[j]);
			if (j != tot*len+1)
				di[tot+1] = min(di[tot],abs(a[j]-a[j-1]));
			map[tot+1][j-tot*len] = a[j];
		}
		tot++;
	}
}

inline void update(int x)
{	
	bi[x] = 0;
	di[x] = si[x] = 2147483644;
	for (int j = 1;j <= l[x]; j++)
	{
		bi[x] = max(bi[tot],map[x][j]);
		si[x] = min(si[tot],map[x][j]);
		if (j != 1)
			di[x] = min(di[tot],abs(map[x][j]-map[x][j-1]));
	}
}
int num,leng;
inline void findx(int x)
{
	num = 1,leng = 0;
	while (leng+l[num] < x && num < tot)
	{
		leng += l[num];
		num++;
	}
}

int main()
{
	freopen("atom.in","r",stdin);
	freopen("atom.out","w",stdout);
	ios::sync_with_stdio(false);
	cin >> n >> m;
	for (int i = 1;i <= n; i++)
		cin >> a[i];
	int typ = findtyp();
	int eps = sqrt(1.0*n);
	if (typ == 1)
	{
		for (int i = 1;i <= m; i++)
		{
			cin >> ord >> aa >> bb;
			if (ord[1] == 'e')
			{
				a[aa] = bb;
				for (int i = aa+1;i < n; i++)
					a[i] = a[i+1];
				n--;
			}
			else if (ord[1] == 'n')
			{
				n++;
				for (int i = n;i > aa+1; i--)
					a[i] = a[i-1];
				a[aa+1] = bb;
			}
			else if (ord[1] == 'a')
			{
				int Ma = 0,Mi = 2147483644;
				for (int i = aa;i <= bb; i++)
					Ma = max(Ma,a[i]),Mi = min(Mi,a[i]);
				cout << Ma-Mi << endl;
			}
			else if (ord[1] == 'i')
			{
				int Mi = 2147483644;
				for (int i = aa;i < bb; i++)
					Mi = min(Mi,abs(a[i]-a[i+1]));
				cout << Mi << endl;
			}
		}
	}
	else if (typ == 2)
	{
		build1(root1,1,n);
		build2(root2,1,n-1);
		for (int i = 1;i <= m; i++)
		{
			cin >> ord >> aa >> bb;
			if (ord[1] == 'a')
				cout << getmax(root1,aa,bb)-getmin(root1,aa,bb) << endl;
			else
				cout << getmin(root2,aa,bb-1) << endl;
		}
	}
	else
	{
		makeblocks();
		for (int i = 1;i <= m; i++)
		{
			cin >> ord >> aa >> bb;
			if (ord[1] == 'e')
			{
				continue;
			}
			else if (ord[1] == 'n')
			{
				cnt++;
				findx(aa);
				int k = num;
				aa -= leng;
				l[k]++;
				for (int i = l[k];i > aa; i--)
					map[k][i] = map[k][i-1];
				map[k][aa+1] = bb;
				update(k);
			}
			else if (ord[1] == 'a')
			{
				int st,ed;
				findx(aa);
				st = num;
				aa -= leng;
				findx(bb);
				ed = num;
				bb -= leng;
				int xi = 2147483644,da = 0;
				if (st < ed)
				{
					for (int j = aa;j <= l[st]; j++)
						da = max(da,map[st][j]),xi = min(xi,map[st][j]);
					for (int j = 1;j <= bb; j++)
						da = max(map[ed][j],da),xi = min(xi,map[ed][j]);
					for (int j = st+1;j < ed; j++)
						da = max(bi[j],da),xi = min(si[j],xi);
				}
				else
				{
					for (int j = aa;j <= bb; j++)
						da = max(da,map[st][j]),xi = min(xi,map[st][j]);
				}
				cout << da-xi << endl;
			}
			else if (ord[1] == 'i')
			{
				aa++;
				int d = 2147483644,st,ed;
				findx(aa);
				aa -= leng;
				st = num;
				findx(bb);
				ed = num;
				bb -= leng;
				if (st < ed)
				{
					if (aa == 1)
						st--;
					else
					{
						for (int j = aa;j <= l[st]; j++)
							d = min(d,abs(map[st][j]-map[st][j-1]));
					}
					for (int j = 2;j <= bb; j++)
						d = min(d,abs(map[ed][j]-map[ed][j-1]));
					for (int j = st+1;j < ed; j++)
					{
						d = min(d,di[j]);
						d = min(d,abs(map[j][1]-map[j-1][l[j-1]]));
					}
					d = min(d,abs(map[ed][1]-map[ed-1][l[ed-1]]));
				}
				else
				{
					if (aa == 1)
						d = min(map[st][1]-map[st-1][l[st-1]],d);
					for (int j = max(2,aa);j <= bb; j++)
						d = min(abs(map[st][j]-map[st][j-1]),d);
				}
				cout << d << endl;
			}
			if (cnt == eps)
			{
				n = 0;
				for (int j = 1;j <= tot; j++)
					for (int p = 1;p <= l[j]; p++)
						a[++n] = map[j][p];
				cnt = 0;
				makeblocks();
			}
		}
	}
	return 0;
}
