#include <cstdio>
#include <algorithm>
using namespace std;

const int _N=100007,_I=1050000000;

#define $s if(0) /* debug flag */

//splay
int SPLAYROOT=1,splaytop=1; // ++splaytop
int son[_N][2],par[_N],size[_N],
	value[_N],mi[_N],ma[_N],vl[_N],vr[_N],gap[_N];

inline bool flag(int x) {
	return x==x[par][son][1];
}

inline void splaydebug(int x) {
	$s { // to make sure no silly output is made
		printf("node %d : vl %d ; vr %d ; value %d ; mi %d ; ma %d ; gap %d\n",x,x[vl],x[vr],x[value],x[mi],x[ma],x[gap]);
		if(x[son][0]) {
			printf("%d --ls-> %d\n",x,x[son][0]);
			splaydebug(x[son][0]);
		}
		if(x[son][1]) {
			printf("%d --rs-> %d\n",x,x[son][1]);
			splaydebug(x[son][1]);
		}
	}
}

inline void update(int x) {
	size[0]=0; mi[0]=_I; ma[0]=-_I; vr[0]=vl[0]=0; value[0]=gap[0]=2*_I;
	
	x[size]=x[son][0][size]+x[son][1][size]+1;
	x[mi]=min(x[value],min(x[son][0][mi],x[son][1][mi]));
	x[ma]=max(x[value],max(x[son][0][ma],x[son][1][ma]));
	x[vl]=x[son][0] ? x[son][0][vl] : x;
	x[vr]=x[son][1] ? x[son][1][vr] : x;
	x[gap]=min(
		min(x[son][0][gap],x[son][1][gap]),
		min(abs(x[son][0][vr][value]-x[value]),abs(x[son][1][vl][value]-x[value]))
	);
}

inline void rotate(int x) {
	int px=x[par],
		ppx=px[par],
		fx=flag(x),
		selfson=x[son][!fx];
	
	x[par]=ppx;
	if(ppx) ppx[son][flag(px)]=x;
	px[par]=x;
	px[son][fx]=selfson;
	if(selfson) selfson[par]=px;
	x[son][!fx]=px;
	
	update(px);
	update(x);
}

inline void splay(int x,int where) {
	if(x==0)
		return;
	$s printf("splay %d to %d\n",x,where);
	int p,pp;
	while((p=x[par])!=where) {
		if(flag(pp=p[par])==flag(p))
			rotate(p);
		rotate(x);
		$s printf("  px = %d\n",x[par]);
	}
	update(x);
	if(where==0)
		SPLAYROOT=x;
}

inline int findk(int k) {
	$s printf("findk %d\n",k);
	int self=SPLAYROOT,lsize;
	while(true) {
		lsize=self[son][0] ? self[son][0][size] : 0;
		$s printf("  lsize = %d , k = %d\n",lsize,k);
		if(lsize>=k)
			self=self[son][0];
		else if(lsize==k-1)
			return self;
		else if(k<=self[size])
			self=self[son][1],
			k-=lsize+1;
		else
			return 0; // not found
	}
}

inline void insert(int k,int val) {
	splay(findk(k),0);
	int fnext=findk(k+1);
	if(fnext) {
		splay(fnext,SPLAYROOT);
		//$s puts("in insert: findk ok");
		SPLAYROOT[son][1][son][0]=++splaytop;
		splaytop[par]=SPLAYROOT[son][1];
	}
	else {
		SPLAYROOT[son][1]=++splaytop;
		splaytop[par]=SPLAYROOT;
	}
	splaytop[size]=1;
	splaytop[value]=splaytop[mi]=splaytop[ma]=val;
	splaytop[vl]=splaytop[vr]=splaytop;
	splaytop[gap]=_I;
	update(splaytop[par]);
}

int main() {
	freopen("atom.in","r",stdin);
	freopen("atom.out","w",stdout);
	
	int points,queries,tmp;
	scanf("%d%d",&points,&queries);
	scanf("%d",&tmp);
	
	SPLAYROOT[value]=SPLAYROOT[mi]=SPLAYROOT[ma]=tmp;
	SPLAYROOT[size]=1;
	SPLAYROOT[vl]=SPLAYROOT[vr]=SPLAYROOT;
	
	SPLAYROOT[son][0]=++splaytop;
	splaytop[mi]=splaytop[ma]=splaytop[value]=-_I;
	splaytop[size]=1;
	splaytop[par]=SPLAYROOT;
	splaytop[vl]=splaytop[vr]=splaytop;
		
	SPLAYROOT[son][1]=++splaytop;
	splaytop[mi]=splaytop[ma]=splaytop[value]=_I;
	splaytop[size]=1;
	splaytop[par]=SPLAYROOT;
	splaytop[vl]=splaytop[vr]=splaytop;
	
	update(SPLAYROOT);
	
	for(int i=2;i<=points;i++) {
		int tmp;
		scanf("%d",&tmp);
		insert(i,tmp);
		$s {
			puts(" +++++");
			splaydebug(SPLAYROOT);
			puts(" =====");
		}
	}
	while(queries--) {
		char cmd; int a1,a2;
		scanf("%*c%*c%c%*s%d%d",&cmd,&a1,&a2);
		if(cmd=='a') { // max
			splay(findk(a1),0);
			splay(findk(a2+2),SPLAYROOT);
			int target=SPLAYROOT[son][1][son][0];
			$s splaydebug(SPLAYROOT);
			printf("%d\n",target[ma]-target[mi]);
		} else if(cmd=='i') { // min
			splay(findk(a1),0);
			splay(findk(a2+2),SPLAYROOT);
			$s splaydebug(SPLAYROOT);
			printf("%d\n",SPLAYROOT[son][1][son][0][gap]);
		} else if(cmd=='e') { // merge
			$s puts("merge: delete");
			splay(findk(a1+1),0);
			splay(findk(a1+3),SPLAYROOT);
			SPLAYROOT[son][1][son][0][par]=0;
			SPLAYROOT[son][1][son][0]=0;
			update(SPLAYROOT[son][1]);
			
			$s puts("merge: update");
			splay(findk(a1),0);
			splay(findk(a1+2),SPLAYROOT);
			int target=SPLAYROOT[son][1][son][0];
			target[value]=target[mi]=target[ma]=a2;
			update(SPLAYROOT[son][1]);
		} else if(cmd=='n') { // insert
			insert(a1+1,a2);
		}
	}
	return 0;
}
