#include <cstdio>

using namespace std;

const int INF = 1 << 30;
const int MAXN = 100001;
const int L = 500, D = 320;//block's max_len & init_len
const int BS = 1001;//max number of blocks

int a[MAXN];
int pool[L * BS], ps;

struct Block{
	int len;//number of elements now
	int li;//starting position in array (pool[li..li+len-1(..li+L-1)])
	int max, min, dmin;//max & min element, min substraction
	int pre, nxt;//pre & nxt block
} b[BS];

int br, bs;//head/size of block list
int n, m;
int ans_max, ans_min, ans_dmin;

inline int Mabs(int x){
	return x < 0 ? -x : x;
}

void chkd(int &x, int p){//check x with abs(pre[p]->tail - p->head)
	if (!p || !b[p].pre) return;
	int w = pool[b[b[p].pre].li+b[b[p].pre].len-1];
	int c = Mabs(pool[b[p].li] - w);
	if (c < x) x = c;
}

void relax(int p){//caculate keys of block[p]
	if (!b[p].len){//empty
		b[b[p].pre].nxt = b[p].nxt;
		if (br == p) br = b[p].nxt;
		if (b[p].nxt) b[b[p].nxt].pre = b[p].pre;
		return;
	}
	int l = b[p].li, r = b[p].li+b[p].len-1;
	b[p].max = b[p].min = pool[l]; b[p].dmin = INF;
	for (int i = l+1; i <= r; i ++){
		if (pool[i] > b[p].max) b[p].max = pool[i];
		if (pool[i] < b[p].min) b[p].min = pool[i];
		if (Mabs(pool[i] - pool[i-1]) < b[p].dmin) b[p].dmin = Mabs(pool[i] - pool[i-1]);
	}
}

void split(int p){//divide block[p] into two part
	if (b[p].len != L) return;
	int p1 = ++ bs;
	b[p1].pre = p; b[p1].nxt = b[p].nxt;
	b[p].nxt = p1; b[b[p1].nxt].pre = p1;
	b[p1].len = b[p].len = L / 2;
	for (int i = 0; i < L/2; i ++)
		pool[ps+i] = pool[b[p].li+L/2+i];
	b[p1].li = ps; ps += L;
	relax(p);
	relax(p1);
}

void init(){
	for (int i = 1; i <= n; i += D){
		int p = ++ bs;
		if (bs == 1) br = p;
			else b[p-1].nxt = p;
		b[p].pre = p-1;
		int l = D;
		if (l > n-i+1) l = n-i+1;
		for (int j = 0; j < l; j ++)
			pool[ps+j] = a[i+j];
		b[p].li = ps; ps += L;
		b[p].len = l;
		relax(p);
	}
}

void merge(int x, int e){
	int c = 0;
	for (int i = br; i && x > c; i = b[i].nxt){
		c += b[i].len;
		if (c < x) continue;
		if (x == c){//x+1 in next block
			b[i].len --;
			pool[b[b[i].nxt].li] = e;
			relax(i);
			relax(b[i].nxt);
		} else {//x & x+1 in the same bock
			int x1 = b[i].li+x-(c-b[i].len), rr = b[i].li+b[i].len-1;
			for (int j = x1; j < rr; j ++)
				pool[j] = pool[j+1];
			pool[x1-1] = e; b[i].len --;
			relax(i);
		}
	}
}

void insert(int x, int e){
	int c = 0;
	for (int i = br; i && x > c; i = b[i].nxt){
		c += b[i].len;
		if (c < x) continue;
		if (b[i].len == L){//full
			split(i);
			c -= L/2;
			if (c < x) continue;
		}
		int x1 = b[i].li+x-(c-b[i].len);
		for (int j = b[i].li+b[i].len-1; j >= x1; j --)
			pool[j+1] = pool[j];
		pool[x1] = e; b[i].len ++;
		relax(i);
	}
}

void ask(int l, int r){
	int c = 0;
	ans_min = ans_dmin = INF; ans_max = 0;
	for (int i = br; i && r > c; i = b[i].nxt){
		c += b[i].len;
		if (c < l) continue;
		if (l <= c-b[i].len+1 && r >= c){//contain
			if (b[i].max > ans_max) ans_max = b[i].max;
			if (b[i].min < ans_min) ans_min = b[i].min;
			if (b[i].dmin < ans_dmin) ans_dmin = b[i].dmin;
			chkd(ans_dmin, i);
			continue;
		}
		int ll = b[i].li, rr = b[i].li+b[i].len-1;
		if (l > c-b[i].len+1) ll += l-(c-b[i].len+1);
		if (r < c) rr -= c-r;
		for (int k = ll; k <= rr; k ++){
			if (pool[k] > ans_max) ans_max = pool[k];
			if (pool[k] < ans_min) ans_min = pool[k];
			if (k > b[i].li && Mabs(pool[k] - pool[k-1]) < ans_dmin)
				ans_dmin = Mabs(pool[k] - pool[k-1]);
		}
		if (ll == b[i].li) chkd(ans_dmin, i);
	}
}

int main()
{
	freopen("atom.in", "r", stdin);
	freopen("atom.out", "w", stdout);
	scanf("%d%d", &n, &m);
	for (int i = 1; i <= n; i ++)
		scanf("%d", &a[i]);
	init();
	for (int i = 0; i < m; i ++){
		char st[7]; int x, y;
		scanf("%s%d%d", st, &x, &y);
		if (st[0] == 'i'){//insert
			insert(x, y);
		} else if (st[1] == 'e'){//merge
			merge(x, y);
		} else if (st[1] == 'a'){//max
			ask(x, y);
			printf("%d\n", ans_max - ans_min);
		} else if (st[1] == 'i'){//min
			ask(x+1, y);
			printf("%d\n", ans_dmin);
		} else
			puts("error!");
	}
	return 0;
}
