#include <map>
#include <queue>
#include <cstdio>
#include <algorithm>

using namespace std;

const int MAXN = 19, MAXM = 151, MAXS = (1 << 19);

typedef long long LL;
typedef pair <int, LL> P;

int force[MAXN];
int ex[MAXM], ey[MAXM];
int fa[MAXN], lc[MAXN], rc[MAXN];
int id[MAXN], li[MAXN], ri[MAXN];
int cur[MAXN];
P que[MAXS];//bfs
map <LL, int> States;//g
priority_queue <P> Que;//A*, f=g+h
int n, m, ans;

LL encode(){
	LL x = 0;
	for (int i = 0; i < n; i ++)
		x = x * n + cur[i];
	return x;
}

void decode(LL x){
	for (int i = n-1; i >= 0; i --){
		cur[i] = x % n; x /= n;
	}
}

int greedy(){
	int tmp[MAXN];
	for (int i = 0; i < n; i ++)
		tmp[i] = cur[i];
	int s = 0;
	for (int i = 0; i < n; i ++){
		int u = id[i], w = u;
		for (int j = li[u]; j <= ri[u]; j ++)
			if (force[tmp[id[j]]] > force[tmp[w]])
				w = id[j];
		if (w == u)
			continue;
		s ++;
		int t = tmp[u];
		tmp[u] = tmp[w];
		tmp[w] = t;
	}
	return s;
}

void dfs(int u, int &t)
{
	id[t ++] = u;
	li[u] = t;
	if (lc[u] != -1) dfs(lc[u], t);
	if (rc[u] != -1) dfs(rc[u], t);
	ri[u] = t-1;
}

void init(){
	for (int i = 0; i < n; i ++)
		lc[i] = rc[i] = -1;
	for (int i = 0; i < n; i ++)
		if (fa[i] != -1){
			if (lc[fa[i]] == -1) lc[fa[i]] = i;
				else rc[fa[i]] = i;
		}
	for (int i = 0; i < n; i ++)
		if (fa[i] == -1){//i is root
			int t = 0;
			dfs(i, t);
			break;
		}
}

bool isChain(){
	for (int i = 0; i < n; i ++)
		if (!(li[id[i]] == i+1 && ri[id[i]] == n-1))
			return 0;
	return 1;
}

void swap(int i, int j){
	int t = cur[i]; cur[i] = cur[j]; cur[j] = t;
}

int bfs(){
	if (!greedy())
		return 0;
	int qh = 0, qt = 0;
	P s = make_pair(0, encode());
	que[qh] = s; States[encode()] = 1;
	while (qh <= qt){
		s = que[qh ++];
		decode(s.second);
		for (int k = 0; k < m; k ++){
			swap(ex[k], ey[k]);
			if (!greedy())//end
				return s.first + 1;
			LL sn = encode();
			if (States.find(sn) != States.end()){//exists
				swap(ex[k], ey[k]);
				continue;
			}
			States[sn] = 1;
			if (qt < MAXS-1)//expand
				que[++ qt] = make_pair(s.first + 1, sn);
			swap(ex[k], ey[k]);//restore
		}
	}
	return -1;
}

int Astar(){
	P s = make_pair(-greedy(), encode());
	States[s.second] = 0;
	Que.push(s);
	if (s.first == 0)
		return 0;
	while (!Que.empty()){
		s = Que.top(); Que.pop();
		decode(s.second);
		int g = States[s.second];
		for (int k = 0; k < m; k ++){//enumerate
			swap(ex[k], ey[k]);
			LL sn = encode();
			if (States.find(sn) != States.end()){
				swap(ex[k], ey[k]);
				continue;
			}
			int f = g + 1 + greedy();
			if (f == g + 1)//end
				return f;
			States[sn] = g + 1;
			Que.push(make_pair(-f, sn));
			swap(ex[k], ey[k]);
		}
	}
	return -1;
}

int main()
{
	freopen("interstellar.in", "r", stdin);
	freopen("interstellar.out", "w", stdout);
	//input
	scanf("%d%d", &n, &m);
	for (int i = 0; i < n; i ++){
		scanf("%d", &fa[i]); fa[i] --;
	}
	for (int i = 0; i < n; i ++)
		scanf("%d", &force[i]);
	for (int i = 0; i < m; i ++){
		scanf("%d%d", &ex[i], &ey[i]);
		ex[i] --; ey[i] --;
	}
	//prepare
	init();
	//solve
	for (int i = 0; i < n; i ++)
		cur[i] = i;
	if (isChain()){
		if (m == n*(n-1)/2)
			ans = greedy();
		else
			ans = Astar();
	} else {
		ans = bfs();
	}
	printf("%d\n", ans);
	return 0;
}
